searchData={"items":[{"type":"task","title":"mix playwright.install","doc":"Installs Playwright browsers.\n\n```bash\n$ mix playwright.install\n```","ref":"Mix.Tasks.Playwright.Install.html"},{"type":"module","title":"Playwright.Page.Keyboard","doc":"`Keyboard` provides an API for managing a virtual keyboard. The high level API\nis `keyboard.type()`, which takes raw characters and generates proper\n`keydown`, `keypress`/`input`, and `keyup` events on your page.\n\nFor finer control, you can use `keyboard.down()`, `keyboard.up()`, and\n`keyboard.insertText()` to manually fire events as if they were generated\nfrom a real keyboard.","ref":"Playwright.Page.Keyboard.html"},{"type":"module","title":"Examples - Playwright.Page.Keyboard","doc":"###","ref":"Playwright.Page.Keyboard.html#module-examples"},{"type":"function","title":"Playwright.Page.Keyboard.down/2","doc":"","ref":"Playwright.Page.Keyboard.html#down/2"},{"type":"function","title":"Playwright.Page.Keyboard.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Page.Keyboard.html#init/2"},{"type":"function","title":"Example - Playwright.Page.Keyboard.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Page.Keyboard.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Page.Keyboard.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Page.Keyboard.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Page.Keyboard.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Page.Keyboard.html#init/2-arguments"},{"type":"function","title":"Playwright.Page.Keyboard.insert_text/2","doc":"","ref":"Playwright.Page.Keyboard.html#insert_text/2"},{"type":"function","title":"Playwright.Page.Keyboard.press/2","doc":"","ref":"Playwright.Page.Keyboard.html#press/2"},{"type":"function","title":"Playwright.Page.Keyboard.type/2","doc":"","ref":"Playwright.Page.Keyboard.html#type/2"},{"type":"function","title":"Playwright.Page.Keyboard.up/2","doc":"","ref":"Playwright.Page.Keyboard.html#up/2"},{"type":"type","title":"Playwright.Page.Keyboard.t/0","doc":"%Playwright.Page.Keyboard{}","ref":"Playwright.Page.Keyboard.html#t:t/0"},{"type":"module","title":"Playwright.Tracing","doc":"...","ref":"Playwright.Tracing.html"},{"type":"function","title":"Playwright.Tracing.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Tracing.html#init/2"},{"type":"function","title":"Example - Playwright.Tracing.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Tracing.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Tracing.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Tracing.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Tracing.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Tracing.html#init/2-arguments"},{"type":"type","title":"Playwright.Tracing.t/0","doc":"%Playwright.Tracing{}","ref":"Playwright.Tracing.html#t:t/0"},{"type":"module","title":"Playwright","doc":"`Playwright` launches and manages with Playwright browser-server instances.\n\nAn example of using `Playwright` to drive automation:","ref":"Playwright.html"},{"type":"module","title":"Example - Playwright","doc":"alias Playwright.API.{Browser, Page, Response}\n\n    {:ok, browser}  = Playwright.launch(:chromium)\n    {:ok, page}     = Browser.new_page(browser)\n    {:ok, response} = Page.goto(browser, \"http://example.com\")\n\n    assert Response.ok(response)\n\n    Browser.close(browser)","ref":"Playwright.html#module-example"},{"type":"function","title":"Playwright.connect/2","doc":"Initiates an instance of `Playwright.Browser` use the WebSocket transport.\n\nNote that this approach assumes the a Playwright Server is running and\nhandling WebSocket requests at the configured `ws_endpoint`.","ref":"Playwright.html#connect/2"},{"type":"function","title":"Returns - Playwright.connect/2","doc":"- `{:ok, Playwright.Browser.t()}`","ref":"Playwright.html#connect/2-returns"},{"type":"function","title":"Arguments - Playwright.connect/2","doc":"| key/name  | typ   |             | description |\n| ----------| ----- | ----------- | ----------- |\n| `client`  | param | `client()`  | The type of client (browser) to launch. |\n| `options` | param | `options()` | `Playwright.SDK.Config.connect_options()` |","ref":"Playwright.html#connect/2-arguments"},{"type":"function","title":"Playwright.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.html#init/2"},{"type":"function","title":"Example - Playwright.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.html#init/2-example"},{"type":"function","title":"Returns - Playwright.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.html#init/2-arguments"},{"type":"function","title":"Playwright.launch/2","doc":"Initiates an instance of `Playwright.Browser` use the Driver transport.","ref":"Playwright.html#launch/2"},{"type":"function","title":"Returns - Playwright.launch/2","doc":"- `{:ok, Playwright.Browser.t()}`","ref":"Playwright.html#launch/2-returns"},{"type":"function","title":"Arguments - Playwright.launch/2","doc":"| key/name  | typ   |             | description |\n| ----------| ----- | ----------- | ----------- |\n| `client`  | param | `client()`  | The type of client (browser) to launch. |\n| `options` | param | `options()` | `Playwright.SDK.Config.launch_options()` |","ref":"Playwright.html#launch/2-arguments"},{"type":"type","title":"Playwright.client/0","doc":"The web client type used for `launch` and `connect` functions.","ref":"Playwright.html#t:client/0"},{"type":"type","title":"Playwright.t/0","doc":"%Playwright{}","ref":"Playwright.html#t:t/0"},{"type":"module","title":"Playwright.APIRequestContext","doc":"This API is used for the Web API testing. You can use it to trigger API endpoints, configure micro-services,\nprepare environment or the server to your e2e test.\n\nUse this at caution as has not been tested.","ref":"Playwright.APIRequestContext.html"},{"type":"function","title":"Playwright.APIRequestContext.body/2","doc":"","ref":"Playwright.APIRequestContext.html#body/2"},{"type":"function","title":"Playwright.APIRequestContext.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.APIRequestContext.html#init/2"},{"type":"function","title":"Example - Playwright.APIRequestContext.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.APIRequestContext.html#init/2-example"},{"type":"function","title":"Returns - Playwright.APIRequestContext.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.APIRequestContext.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.APIRequestContext.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.APIRequestContext.html#init/2-arguments"},{"type":"function","title":"Playwright.APIRequestContext.post/3","doc":"","ref":"Playwright.APIRequestContext.html#post/3"},{"type":"type","title":"Playwright.APIRequestContext.fetch_options/0","doc":"","ref":"Playwright.APIRequestContext.html#t:fetch_options/0"},{"type":"type","title":"Playwright.APIRequestContext.t/0","doc":"%Playwright.APIRequestContext{}","ref":"Playwright.APIRequestContext.html#t:t/0"},{"type":"module","title":"Playwright.Browser","doc":"A `Playwright.Browser` instance is created via:\n\n  - `Playwright.BrowserType.launch/0`, when using the \"driver\" transport.\n  - `Playwright.BrowserType.connect/1`, when using the \"websocket\" transport.\n\nAn example of using a `Playwright.Browser` to create a `Playwright.Page`:\n\n    alias Playwright.{Browser, Page}\n\n    {:ok, browser} = Playwright.launch(:chromium)\n    page = Browser.new_page(browser)\n\n    Page.goto(page, \"https://example.com\")\n    Browser.close(browser)","ref":"Playwright.Browser.html"},{"type":"module","title":"Properties - Playwright.Browser","doc":"- `:name`\n  - `:version`","ref":"Playwright.Browser.html#module-properties"},{"type":"function","title":"Playwright.Browser.close/1","doc":"Closes the browser.\n\nGiven a `Playwright.Browser` obtained from `Playwright.BrowserType.launch/2`,\ncloses the `Browser` and all of its `Pages` (if any were opened).\n\nGiven a `Playwright.Browser` obtained via `Playwright.BrowserType.connect/2`,\nclears all created `Contexts` belonging to this `Browser` and disconnects\nfrom the browser server.\n\nThe Browser object itself is considered to be disposed and cannot be used anymore.","ref":"Playwright.Browser.html#close/1"},{"type":"function","title":"Returns - Playwright.Browser.close/1","doc":"- `:ok`","ref":"Playwright.Browser.html#close/1-returns"},{"type":"function","title":"Playwright.Browser.contexts/1","doc":"Returns a list of all open browser contexts. In a newly created browser,\nthis will return zero browser contexts.","ref":"Playwright.Browser.html#contexts/1"},{"type":"function","title":"Example - Playwright.Browser.contexts/1","doc":"contexts = Browser.contexts(browser)\n    asset Enum.empty?(contexts)\n\n    Browser.new_context(browser)\n\n    contexts = Browser.contexts(browser)\n    assert length(contexts) == 1","ref":"Playwright.Browser.html#contexts/1-example"},{"type":"function","title":"Playwright.Browser.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Browser.html#init/2"},{"type":"function","title":"Example - Playwright.Browser.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Browser.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Browser.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Browser.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Browser.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Browser.html#init/2-arguments"},{"type":"function","title":"Playwright.Browser.new_context/2","doc":"Create a new `Playwright.BrowserContext` for this `Playwright.Browser`.\n\nA `BrowserContext` does not share cookies/cache with other `BrowserContexts`\nand is somewhat equivalent to an \"incognito\" browser \"window\".","ref":"Playwright.Browser.html#new_context/2"},{"type":"function","title":"Example - Playwright.Browser.new_context/2","doc":"# create a new \"incognito\" browser context.\n    context = Browser.new_context(browser)\n\n    # create a new page in a pristine context.\n    page = BrowserContext.new_page(context)\n\n    Page.goto(page, \"https://example.com\")","ref":"Playwright.Browser.html#new_context/2-example"},{"type":"function","title":"Returns - Playwright.Browser.new_context/2","doc":"- `Playwright.BrowserContext.t()`","ref":"Playwright.Browser.html#new_context/2-returns"},{"type":"function","title":"Arguments - Playwright.Browser.new_context/2","doc":"| key/name         | type   |             | description |\n| ------------------ | ------ | ----------- | ----------- |\n| `accept_downloads` | option | `boolean()` | Whether to automatically download all the attachments. If false, all the downloads are canceled. `(default: false)` |\n| `...`              | option | `...`       | ... |","ref":"Playwright.Browser.html#new_context/2-arguments"},{"type":"function","title":"Playwright.Browser.new_page/2","doc":"Create a new `Playwright.Page` for this Browser, within a new \"owned\"\n`Playwright.BrowserContext`.\n\nThat is, `Playwright.Browser.new_page/2` will also create a new\n`Playwright.BrowserContext`. That `BrowserContext` becomes, both, the\n*parent* of the `Page`, and *owned by* the `Page`. When the `Page` closes,\nthe context goes with it.\n\nThis is a convenience API function that should only be used for single-page\nscenarios and short snippets. Production code and testing frameworks should\nexplicitly create via `Playwright.Browser.new_context/2` followed by\n`Playwright.BrowserContext.new_page/2`, given the new context, to manage\nresource lifecycles.","ref":"Playwright.Browser.html#new_page/2"},{"type":"function","title":"Playwright.Browser.version/1","doc":"Returns the browser version","ref":"Playwright.Browser.html#version/1"},{"type":"type","title":"Playwright.Browser.event/0","doc":"Supported events","ref":"Playwright.Browser.html#t:event/0"},{"type":"type","title":"Playwright.Browser.options/0","doc":"A map/struct providing call options","ref":"Playwright.Browser.html#t:options/0"},{"type":"type","title":"Playwright.Browser.t/0","doc":"%Playwright.Browser{}","ref":"Playwright.Browser.html#t:t/0"},{"type":"module","title":"Playwright.BrowserContext","doc":"`Playwright.BrowserContext` provides a way to operate multiple independent\nbrowser sessions.\n\nIf a page opens another page, e.g. with a `window.open` call, the popup will\nbelong to the parent page's browser context.\n\nPlaywright allows creation of \"incognito\" browser contexts with the\n`Playwright.Browser.new_context/1` function.","ref":"Playwright.BrowserContext.html"},{"type":"module","title":"Example - Playwright.BrowserContext","doc":"# create a new \"incognito\" browser context:\n    context = Playwright.Browser.new_context(browser)\n\n    # create and use a new page within that context:\n    page = Playwright.BrowserContext.new_page(context)\n    resp =  = Playwright.Page.goto(page, \"https://example.com\")\n\n    # dispose the context once it's no longer needed:\n    Playwright.BrowserContext.close(context)","ref":"Playwright.BrowserContext.html#module-example"},{"type":"module","title":"Regarding `expect_event/5` and `on/3` - Playwright.BrowserContext","doc":"The first argument given to `on/3` and `expect_event/5` functions is the\n\"owner\" on which to bind the event.\n\nThe second argument is the event type.\n\nThe third argument is a callback function that will be executed when the\nevent fires, and is passed an instance of `Playwright.SDK.Channel.Event`.","ref":"Playwright.BrowserContext.html#module-regarding-expect_event-5-and-on-3"},{"type":"module","title":"Details for `expect_event/5` - Playwright.BrowserContext","doc":"Calls to `expect_event/5` are blocking. These functions take a \"trigger\",\nexecution of which is expected to result in the event being fired.\n\nIf the event does not fire within the timeout window, the call to\n`expect_event/5` will timeout.\n\nAn optional \"predicate\" function may be provided, in which case the fired\nevent will be sent to the predicate, which must return a \"truthy\" result\nin order for the expectation to be fulfilled.\n\n    e = BrowserContext.expect_event(context, :close, fn ->\n      Page.close(page)\n    end)\n    assert %BrowserContext{} = e.target","ref":"Playwright.BrowserContext.html#module-details-for-expect_event-5"},{"type":"module","title":"Details for `on/3` - Playwright.BrowserContext","doc":"Calls to `on/3` are non-blocking and register callbacks for the lifetime\nof the binding target.\n\n    BrowserContext.on(context, :close, fn e ->\n      assert %BrowserContext{} = e.target\n    end)","ref":"Playwright.BrowserContext.html#module-details-for-on-3"},{"type":"module","title":"Event types - Playwright.BrowserContext","doc":"The `expect_event/5` and `on/3` functions support the following event types:\n\n  - `:background_page`\n\n    Emitted when a new background page is created in the context. The event\n    target is a `Playwright.Page`.\n\n        ...\n\n    > NOTE:\n    >\n    > - Only works with Chromium browser's persistent context.\n\n  - `:close`\n\n    Emitted when the `Playwright.BrowserContext` is closed. The event target\n    is a `Playwright.BrowserContext`. This might happen because of any of the\n    following:\n\n      - Browser context is closed.\n      - Browser application is closed or crashed.\n      - `Playwright.Browser.close/1` is called.\n      - `Playwright.Page.close/1` is with the \"owner page\" for this context.\n\n  - `:page`\n\n    Emitted when a new `Playwright.Page` is created within the context.\n    The page may still be loading. The event target is a `Playwright.Page`.\n\n    The event will also fire for popup pages.\n\n    The earliest moment that a page is available is when it has navigated to\n    the initial URL. For example, when opening a popup with\n    `window.open('http://example.com')`, this event will fire when the\n    network request to \"http://example.com\" is done and its response has\n    started loading in the popup.\n\n        BrowserContext.expect_event(context, :page, fn ->\n          Page.click(page, \"a[target=_blank]\")\n        end)\n\n    > NOTE:\n    >\n    > - Use `Playwright.Page.wait_for_load_state/3` to wait until the page\n    >   gets to a particular state (you should not need it in most cases).\n\n  - `:request`\n\n    Emitted when a request is issued from any pages created through this\n    context. The event target is a `Playwright.Request`.\n\n    To only listen for requests from a particular page, use\n    `Playwright.Page.on/3` (for `:request`).\n\n    In order to intercept and mutate requests, see `route/4` or\n    `Playwright.Page.route/4`.\n\n  - `:request_failed`\n\n    Emitted when a request fails, for example by timing out. The event\n    target is a `Playwright.Request`.\n\n    To only listen for failed requests from a particular page, use\n    `Playwright.Page.on/3` (for `:request_failed`).\n\n    > NOTE:\n    >\n    > - HTTP error responses, such as 404 or 503, are still successful\n    >   responses from HTTP standpoint. So, the request will complete with\n    >   a `:request_finished` event and not with `:request_failed`.\n\n  - `:request_finished`\n\n    Emitted when a request finishes successfully after downloading the\n    response body. The event target is a `Playwright.Request`.\n\n    For a successful response, the sequence of events is `:request`,\n    `:response` and `:request_finished`. To listen for successful requests\n    from a particular page, use `Playwright.Page.on/3` (for\n    `:request_finished`).\n\n  - `:response`\n\n    Emitted when response status and headers are received for a request.\n    The event target is a `Playwright.Response`.\n\n    For a successful response, the sequence of events is `:request`,\n    `:response` and `:request_finished`. To listen for response events\n    from a particular page, use `Playwright.Page.on/3` (for  `:response`).\n\n  - `:service_worker`\n\n    Emitted when new service worker is created in the context. The event\n    target is a `Playwright.Worker`.\n\n    > NOTE:\n    >\n    > - Service workers are only supported on Chromium-based browsers.","ref":"Playwright.BrowserContext.html#module-event-types"},{"type":"function","title":"Playwright.BrowserContext.add_cookies/2","doc":"Adds cookies into this `Playwright.BrowserContext`.\n\nAll pages within this context will have these cookies installed. Cookies can\nbe obtained via `Playwright.BrowserContext.cookies/1`.","ref":"Playwright.BrowserContext.html#add_cookies/2"},{"type":"function","title":"Returns - Playwright.BrowserContext.add_cookies/2","doc":"- `:ok`","ref":"Playwright.BrowserContext.html#add_cookies/2-returns"},{"type":"function","title":"Example - Playwright.BrowserContext.add_cookies/2","doc":":ok = BrowserContext.add_cookies(context, [cookie_1, cookie_2])","ref":"Playwright.BrowserContext.html#add_cookies/2-example"},{"type":"function","title":"Cookie fields - Playwright.BrowserContext.add_cookies/2","doc":"| key         | type        | description |\n| ----------  | ----------- | ----------- |\n| `:name`     | `binary()`  | |\n| `:value`    | `binary()`  | |\n| `:url`      | `binary()`  | *(optional)* either url or domain / path are required |\n| `:domain`   | `binary()`  | *(optional)* either url or domain / path are required |\n| `:path`     | `binary()`  | *(optional)* either url or domain / path are required |\n| `:expires`  | `float()`   | *(optional)* Unix time in seconds. |\n| `:httpOnly` | `boolean()` | *(optional)* |\n| `:secure`   | `boolean()` | *(optional)* |\n| `:sameSite` | `binary()`  | *(optional)* one of \"Strict\", \"Lax\", \"None\" |","ref":"Playwright.BrowserContext.html#add_cookies/2-cookie-fields"},{"type":"function","title":"Playwright.BrowserContext.add_init_script/2","doc":"Adds a script to be evaluated before other scripts.\n\nThe script is evaluated in the following scenarios:\n\n- Whenever a page is created in the browser context or is navigated.\n- Whenever a child frame is attached or navigated in any page in the browser\n  context. In this case, the script is evaluated in the context of the newly\n  attached frame.\n\nThe script is evaluated after the document is created but before any of its\nscripts are run. This is useful to amend the JavaScript environment, e.g. to\nseed `Math.random`.","ref":"Playwright.BrowserContext.html#add_init_script/2"},{"type":"function","title":"Returns - Playwright.BrowserContext.add_init_script/2","doc":"- `:ok`","ref":"Playwright.BrowserContext.html#add_init_script/2-returns"},{"type":"function","title":"Arguments - Playwright.BrowserContext.add_init_script/2","doc":"| key/name  | type   |                       | description |\n| ----------- | ------ | --------------------- | ----------- |\n| `script`    | param  | `binary()` or `map()` | As `binary()`: an inlined script to be evaluated; As `%{path: path}`: a path to a JavaScript file. |","ref":"Playwright.BrowserContext.html#add_init_script/2-arguments"},{"type":"function","title":"Example - Playwright.BrowserContext.add_init_script/2","doc":"Overriding `Math.random` before the page loads:\n\n    # preload.js\n    Math.random = () => 42;\n\n    BrowserContext.add_init_script(context, %{path: \"preload.js\"})","ref":"Playwright.BrowserContext.html#add_init_script/2-example"},{"type":"function","title":"Notes - Playwright.BrowserContext.add_init_script/2","doc":"> While the official Node.js Playwright implementation supports an optional\n> `param: arg` for this function, the official Python implementation does\n> not. This implementation matches the Python for now.\n\n> The order of evaluation of multiple scripts installed via\n> `Playwright.BrowserContext.add_init_script/2` and\n> `Playwright.Page.add_init_script/2` is not defined.","ref":"Playwright.BrowserContext.html#add_init_script/2-notes"},{"type":"function","title":"Playwright.BrowserContext.clear_cookies/1","doc":"Clears `Playwright.BrowserContext` cookies.","ref":"Playwright.BrowserContext.html#clear_cookies/1"},{"type":"function","title":"Playwright.BrowserContext.clear_permissions/1","doc":"","ref":"Playwright.BrowserContext.html#clear_permissions/1"},{"type":"function","title":"Playwright.BrowserContext.close/1","doc":"Closes the `Playwright.BrowserContext`. All pages that belong to the\n`Playwright.BrowserContext` will be closed.\n\n> NOTE:\n> - The default browser context cannot be closed.","ref":"Playwright.BrowserContext.html#close/1"},{"type":"function","title":"Playwright.BrowserContext.cookies/2","doc":"Returns cookies for the `Playwright.BrowserContext`.\n\nIf no URLs are specified, this method returns all cookies. If URLs are\nspecified, only cookies that affect those URLs are returned.","ref":"Playwright.BrowserContext.html#cookies/2"},{"type":"function","title":"Returns - Playwright.BrowserContext.cookies/2","doc":"- `[cookie()]` See `add_cookies/2` for cookie field details.","ref":"Playwright.BrowserContext.html#cookies/2-returns"},{"type":"function","title":"Arguments - Playwright.BrowserContext.cookies/2","doc":"| key/name | type  |                            | description |\n| ---------- | ----- | -------------------------- | ----------- |\n| `urls`     | param | `binary()` or `[binary()]` | List of URLs. `(optional)` |","ref":"Playwright.BrowserContext.html#cookies/2-arguments"},{"type":"function","title":"Playwright.BrowserContext.expect_event/4","doc":"Waits for an event to fire (i.e., is blocking) and passes its value into the\npredicate function.\n\nReturns when the predicate returns a truthy value. Throws an error if the\ncontext closes before the event is fired. Returns a `Playwright.SDK.Channel.Event`.","ref":"Playwright.BrowserContext.html#expect_event/4"},{"type":"function","title":"Arguments - Playwright.BrowserContext.expect_event/4","doc":"- `event`: Event name; the same as those passed to `Playwright.BrowserContext.on/3`\n- `predicate`: Receives the `Playwright.SDK.Channel.Event` and resolves to a\n  \"truthy\" value when the waiting should resolve.\n- `options`:\n  - `predicate`: ...\n  - `timeout`: The maximum time to wait in milliseconds. Defaults to 30000\n    (30 seconds). Pass 0 to disable timeout. The default value can be changed\n    via `Playwright.BrowserContext.set_default_timeout/2`.","ref":"Playwright.BrowserContext.html#expect_event/4-arguments"},{"type":"function","title":"Example - Playwright.BrowserContext.expect_event/4","doc":"event_info = BrowserContext.expect_event(context, :page, fn ->\n      BrowserContext.new_page(context)\n    end)","ref":"Playwright.BrowserContext.html#expect_event/4-example"},{"type":"function","title":"Playwright.BrowserContext.expect_page/3","doc":"Executes `trigger` and waits for a new `Playwright.Page` to be created within\nthe `Playwright.BrowserContext`.\n\nIf `predicate` is provided, it passes the `Playwright.Page` value into the\npredicate function, wrapped in `Playwright.SDK.Channel.Event`, and waits for\n`predicate/1` to return a \"truthy\" value. Throws an error if the context\ncloses before new `Playwright.Page` is created.","ref":"Playwright.BrowserContext.html#expect_page/3"},{"type":"function","title":"Arguments - Playwright.BrowserContext.expect_page/3","doc":"- `predicate`: Receives the `Playwright.Page` and resolves to truthy value\n  when the waiting should resolve.\n- `options`:\n  - `predicate`: ...\n  - `timeout`: The maximum time to wait in milliseconds. Defaults to 30000\n    (30 seconds). Pass 0 to disable timeout. The default value can be changed\n    via `Playwright.BrowserContext.set_default_timeout/2`.","ref":"Playwright.BrowserContext.html#expect_page/3-arguments"},{"type":"function","title":"Playwright.BrowserContext.expose_binding/4","doc":"Adds a function called `param:name` on the `window` object of every frame in\nevery page in the context.\n\nWhen called, the function executes `param:callback` and resolves to the return\nvalue of the `callback`.\n\nThe first argument to the `callback` function includes the following details\nabout the caller:\n\n    %{\n      context: %Playwright.BrowserContext{},\n      frame:   %Playwright.Frame{},\n      page:    %Playwright.Page{}\n    }\n\nSee `Playwright.Page.expose_binding/4` for a similar, page-scoped version.","ref":"Playwright.BrowserContext.html#expose_binding/4"},{"type":"function","title":"Playwright.BrowserContext.expose_function/3","doc":"Adds a function called `param:name` on the `window` object of every frame in\nevery page in the context.\n\nWhen called, the function executes `param:callback` and resolves to the return\nvalue of the `callback`.\n\nSee `Playwright.Page.expose_function/3` for a similar, Page-scoped version.","ref":"Playwright.BrowserContext.html#expose_function/3"},{"type":"function","title":"Playwright.BrowserContext.grant_permissions/3","doc":"","ref":"Playwright.BrowserContext.html#grant_permissions/3"},{"type":"function","title":"Playwright.BrowserContext.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.BrowserContext.html#init/2"},{"type":"function","title":"Example - Playwright.BrowserContext.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.BrowserContext.html#init/2-example"},{"type":"function","title":"Returns - Playwright.BrowserContext.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.BrowserContext.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.BrowserContext.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.BrowserContext.html#init/2-arguments"},{"type":"function","title":"Playwright.BrowserContext.new_cdp_session/2","doc":"","ref":"Playwright.BrowserContext.html#new_cdp_session/2"},{"type":"function","title":"Playwright.BrowserContext.new_page/1","doc":"Creates a new `Playwright.Page` in the context.\n\nIf the context is already \"owned\" by a `Playwright.Page` (i.e., was created\nas a side effect of `Playwright.Browser.new_page/1`), will raise an error\nbecause there should be a 1-to-1 mapping in that case.","ref":"Playwright.BrowserContext.html#new_page/1"},{"type":"function","title":"Playwright.BrowserContext.on/3","doc":"Register a (non-blocking) callback/handler for various types of events.","ref":"Playwright.BrowserContext.html#on/3"},{"type":"function","title":"Playwright.BrowserContext.pages/1","doc":"Returns all open pages in the context.","ref":"Playwright.BrowserContext.html#pages/1"},{"type":"function","title":"Returns - Playwright.BrowserContext.pages/1","doc":"- `[Page.t()]`","ref":"Playwright.BrowserContext.html#pages/1-returns"},{"type":"function","title":"Playwright.BrowserContext.route/4","doc":"","ref":"Playwright.BrowserContext.html#route/4"},{"type":"function","title":"Playwright.BrowserContext.set_offline/2","doc":"","ref":"Playwright.BrowserContext.html#set_offline/2"},{"type":"function","title":"Playwright.BrowserContext.unroute/3","doc":"","ref":"Playwright.BrowserContext.html#unroute/3"},{"type":"type","title":"Playwright.BrowserContext.cookie/0","doc":"Recognized cookie fields","ref":"Playwright.BrowserContext.html#t:cookie/0"},{"type":"type","title":"Playwright.BrowserContext.event/0","doc":"Supported events","ref":"Playwright.BrowserContext.html#t:event/0"},{"type":"type","title":"Playwright.BrowserContext.function_or_options/0","doc":"An optional (maybe nil) function or option","ref":"Playwright.BrowserContext.html#t:function_or_options/0"},{"type":"type","title":"Playwright.BrowserContext.options/0","doc":"A map/struct providing call options","ref":"Playwright.BrowserContext.html#t:options/0"},{"type":"type","title":"Playwright.BrowserContext.t/0","doc":"%Playwright.BrowserContext{}","ref":"Playwright.BrowserContext.html#t:t/0"},{"type":"type","title":"Playwright.BrowserContext.url/0","doc":"A string URL","ref":"Playwright.BrowserContext.html#t:url/0"},{"type":"module","title":"Playwright.BrowserType","doc":"`Playwright.BrowserType` provides functions to launch a specific browser\ninstance or connect to an existing one.\n\nThe following is a typical example of using Playwright to drive automation:\n\n    alias Playwright.{Browser, BrowserType, Page}\n\n    {session, browser} = BrowserType.launch(:chromium)\n    page = Browser.new_page(browser)\n\n    Page.goto(page, \"https://example.com\")\n    # other actions...\n\n    Browser.close(browser)","ref":"Playwright.BrowserType.html"},{"type":"module","title":"Example - Playwright.BrowserType","doc":"Open a new chromium via the CLI driver:\n\n    {session, browser} = Playwright.BrowserType.launch()\n\nConnect to a running playwright instance:\n\n    {session, browser} =\n      Playwright.BrowserType.connect(\"ws://localhost:3000/\")","ref":"Playwright.BrowserType.html#module-example"},{"type":"function","title":"Playwright.BrowserType.connect/2","doc":"Attaches Playwright to an existing browser instance over a websocket.","ref":"Playwright.BrowserType.html#connect/2"},{"type":"function","title":"Returns - Playwright.BrowserType.connect/2","doc":"- `{session, %Playwright.Browser{}}`","ref":"Playwright.BrowserType.html#connect/2-returns"},{"type":"function","title":"Arguments - Playwright.BrowserType.connect/2","doc":"| key/name    | type   |                             | description |\n| ------------- | ------ | --------------------------- | ----------- |\n| `ws_endpoint` | param  | `BrowserType.ws_endpoint()` | A browser websocket endpoint to connect to. |\n| `:headers`    | option | `map()`                     | Additional HTTP headers to be sent with websocket connect request |\n| `:slow_mow`   | option | `integer()`                 | Slows down Playwright operations by the specified amount of milliseconds. Useful so that you can see what is going on. `(default: 0)` |\n| `:logger`     | option |                             | Logger sink for Playwright logging |\n| `:timeout`    | option | `integer()`                 | Maximum time in milliseconds to wait for the connection to be established. Pass `0` to disable timeout. `(default: 30_000 (30 seconds))` |","ref":"Playwright.BrowserType.html#connect/2-arguments"},{"type":"function","title":"Playwright.BrowserType.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.BrowserType.html#init/2"},{"type":"function","title":"Example - Playwright.BrowserType.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.BrowserType.html#init/2-example"},{"type":"function","title":"Returns - Playwright.BrowserType.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.BrowserType.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.BrowserType.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.BrowserType.html#init/2-arguments"},{"type":"function","title":"Playwright.BrowserType.launch/2","doc":"Launches a new browser instance via the Playwright driver CLI.","ref":"Playwright.BrowserType.html#launch/2"},{"type":"function","title":"Example - Playwright.BrowserType.launch/2","doc":"# Use `:ignore_default_args` option to filter out `--mute-audio` from\n    # default arguments:\n    {:ok, browser} =\n      Playwright.launch(:chromium, %{ignore_default_args = [\"--mute-audio\"]})","ref":"Playwright.BrowserType.html#launch/2-example"},{"type":"function","title":"Returns - Playwright.BrowserType.launch/2","doc":"- `{session, %Playwright.Browser{}}`","ref":"Playwright.BrowserType.html#launch/2-returns"},{"type":"function","title":"Arguments - Playwright.BrowserType.launch/2","doc":"... (many)","ref":"Playwright.BrowserType.html#launch/2-arguments"},{"type":"function","title":"NOTE - Playwright.BrowserType.launch/2","doc":"> **Chromium-only** Playwright can also be used to control the Google Chrome\n> or Microsoft Edge browsers, but it works best with the version of Chromium\n> it is bundled with. There is no guarantee it will work with any other\n> version. Use `:executable_path` option with extreme caution.\n>\n> If Google Chrome (rather than Chromium) is preferred, a\n> [Chrome Canary](https://www.google.com/chrome/browser/canary.html) or\n> [Dev Channel](https://www.chromium.org/getting-involved/dev-channel) build\n> is suggested.\n>\n> Stock browsers like Google Chrome and Microsoft Edge are suitable for tests\n> that require proprietary media codecs for video playback.\n> See [this article](https://www.howtogeek.com/202825/what%E2%80%99s-the-difference-between-chromium-and-chrome/)\n> for other differences between Chromium and Chrome.\n> [This article](https://chromium.googlesource.com/chromium/src/+/lkgr/docs/chromium_browser_vs_google_chrome.md)\n> describes some differences for Linux users.","ref":"Playwright.BrowserType.html#launch/2-note"},{"type":"type","title":"Playwright.BrowserType.client/0","doc":"The web client type used for `launch/1` and `connect/2` functions.","ref":"Playwright.BrowserType.html#t:client/0"},{"type":"type","title":"Playwright.BrowserType.connect_options/0","doc":"Options for `connect/2`","ref":"Playwright.BrowserType.html#t:connect_options/0"},{"type":"type","title":"Playwright.BrowserType.options/0","doc":"A map/struct providing call options","ref":"Playwright.BrowserType.html#t:options/0"},{"type":"type","title":"Playwright.BrowserType.t/0","doc":"%Playwright.BrowserType{}","ref":"Playwright.BrowserType.html#t:t/0"},{"type":"type","title":"Playwright.BrowserType.url/0","doc":"A string URL","ref":"Playwright.BrowserType.html#t:url/0"},{"type":"type","title":"Playwright.BrowserType.ws_endpoint/0","doc":"A websocket endpoint (URL)","ref":"Playwright.BrowserType.html#t:ws_endpoint/0"},{"type":"module","title":"Playwright.ConsoleMessage","doc":"`Playwright.ConsoleMessage` instances are dispatched by page and handled via\n`Playwright.Page.on/3` for the `:console` event type.","ref":"Playwright.ConsoleMessage.html"},{"type":"function","title":"Playwright.ConsoleMessage.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.ConsoleMessage.html#init/2"},{"type":"function","title":"Example - Playwright.ConsoleMessage.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.ConsoleMessage.html#init/2-example"},{"type":"function","title":"Returns - Playwright.ConsoleMessage.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.ConsoleMessage.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.ConsoleMessage.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.ConsoleMessage.html#init/2-arguments"},{"type":"type","title":"Playwright.ConsoleMessage.t/0","doc":"%Playwright.ConsoleMessage{}","ref":"Playwright.ConsoleMessage.html#t:t/0"},{"type":"module","title":"Playwright.ElementHandle","doc":"`ElementHandle` represents an in-page DOM element.\n\n`ElementHandles` can be created with the `Playwright.Page.query_selector/3`\nfunction, and similar.\n\n> ⚠️ DISCOURAGED\n>\n> The use of `Playwright.ElementHandle` is discouraged; use\n> `Playwright.Locator` instances and web-first assertions instead.","ref":"Playwright.ElementHandle.html"},{"type":"module","title":"Example - Playwright.ElementHandle","doc":"handle = Page.q(page, \"a\")\n    :ok = ElementHandle.click(handle)\n\n`ElementHandle` prevents DOM elements from garbage collection unless the\nhandle is disposed with `Playwright.JSHandle.dispose/1`. `ElementHandles`\nare auto-disposed when their origin frame is navigated.\n\nAn `ElementHandle` instance can be used as an argument in\n`Playwright.Page.eval_on_selector/5` and `Playwright.Page.evaluate/3`.","ref":"Playwright.ElementHandle.html#module-example"},{"type":"module","title":"NOTE - Playwright.ElementHandle","doc":"> In most cases, you would want to use `Playwright.Locator` instead. You\n> should only use `ElementHandle` if you want to retain a handle to a\n> particular DOM node that you intend to pass into\n> `Playwright.Page.evaluate/3` as an argument.\n\nThe difference between `Playwright.Locator` and `ElementHandle` is that\n`ElementHandle` points to a particular element, while `Playwright.Locator`\ncaptures the logic of how to retrieve an element.\n\nIn the example below, `handle` points to a particular DOM element on the\npage. If that element changes text or is used by JavaScript to render an\nentirely different component, `handle` still points to that very DOM element.\nThis can lead to unexpected behaviors.\n\n    handle = Page.q(\"text=Submit\")\n    ElementHandle.hover(handle)\n    ElementHandle.click(handle)\n\nWith the `Playwright.Locator`, every time the `locator` is used, an\nup-to-date DOM element is located in the page using the selector. So, in the\nsnippet below, the underlying DOM element is going to be located twice.\n\n    locator = Page.locator(\"text=Submit\")\n    Locator.hover(locator)\n    Locator.click(locator)","ref":"Playwright.ElementHandle.html#module-note"},{"type":"function","title":"Playwright.ElementHandle.bounding_box/1","doc":"","ref":"Playwright.ElementHandle.html#bounding_box/1"},{"type":"function","title":"Playwright.ElementHandle.click/2","doc":"Clicks on the element, performing the following steps:\n\n  1. Wait for \"actionability (guide)\" checks on the element, unless `force: true`\n     option is set.\n  2. Scroll the element into view, if needed.\n  3. Use `Playwright.Page.Mouse` to click the center of the element, or the\n     specified option: `position`.\n  4. Wait for initiated navigations to either succeed or fail, unless\n    `no_wait_after: true` option is set.\n\nIf the element is detached from the DOM at any moment during the action,\nthis function raises.\n\nWhen all steps combined have not finished during the specified `:timeout`,\nthis function raises a `TimeoutError`. Passing zero (`0`) for timeout\ndisables this.","ref":"Playwright.ElementHandle.html#click/2"},{"type":"function","title":"Playwright.ElementHandle.content_frame/1","doc":"Returns the `Playwright.Frame` for element handles referencing iframe nodes,\nor `nil` otherwise.","ref":"Playwright.ElementHandle.html#content_frame/1"},{"type":"function","title":"Playwright.ElementHandle.evaluate/3","doc":"","ref":"Playwright.ElementHandle.html#evaluate/3"},{"type":"function","title":"Playwright.ElementHandle.evaluate_handle/3","doc":"","ref":"Playwright.ElementHandle.html#evaluate_handle/3"},{"type":"function","title":"Playwright.ElementHandle.get_attribute/2","doc":"Returns the value of an element's attribute.","ref":"Playwright.ElementHandle.html#get_attribute/2"},{"type":"function","title":"Playwright.ElementHandle.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.ElementHandle.html#init/2"},{"type":"function","title":"Example - Playwright.ElementHandle.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.ElementHandle.html#init/2-example"},{"type":"function","title":"Returns - Playwright.ElementHandle.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.ElementHandle.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.ElementHandle.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.ElementHandle.html#init/2-arguments"},{"type":"function","title":"Playwright.ElementHandle.is_visible/1","doc":"","ref":"Playwright.ElementHandle.html#is_visible/1"},{"type":"function","title":"Playwright.ElementHandle.q/2","doc":"","ref":"Playwright.ElementHandle.html#q/2"},{"type":"function","title":"Playwright.ElementHandle.query_selector/2","doc":"Searches within an element for a DOM element matching the given selector.\n\nFinds an element matching the specified selector within the subtree of the\n`ElementHandle`. See \"working with selectors (guide)\" for more details.\n\nIf no elements match the selector, returns `nil`.","ref":"Playwright.ElementHandle.html#query_selector/2"},{"type":"function","title":"Playwright.ElementHandle.screenshot/2","doc":"","ref":"Playwright.ElementHandle.html#screenshot/2"},{"type":"function","title":"Playwright.ElementHandle.scroll_into_view/2","doc":"","ref":"Playwright.ElementHandle.html#scroll_into_view/2"},{"type":"function","title":"Playwright.ElementHandle.select_text/2","doc":"","ref":"Playwright.ElementHandle.html#select_text/2"},{"type":"function","title":"Playwright.ElementHandle.string/1","doc":"","ref":"Playwright.ElementHandle.html#string/1"},{"type":"function","title":"Playwright.ElementHandle.text_content/1","doc":"Returns the `node.textContent` (all text within the element).","ref":"Playwright.ElementHandle.html#text_content/1"},{"type":"type","title":"Playwright.ElementHandle.options/0","doc":"A map/struct providing call options","ref":"Playwright.ElementHandle.html#t:options/0"},{"type":"type","title":"Playwright.ElementHandle.t/0","doc":"%Playwright.ElementHandle{}","ref":"Playwright.ElementHandle.html#t:t/0"},{"type":"module","title":"Playwright.Frame","doc":"At any point of time, `Playwright.Page` exposes its current frame tree via\nthe `Playwright.Page.main_frame/1` and `Playwright.Frame.child_frames/1`\nfunctions.\n\nA `Frame` instance lifecycle is governed by three events, dispatched on the\n`Playwright.Page` resource:\n\n  - `Page event: :frame_attached` - fired when the frame gets attached to the\n    page. A Frame can be attached to the page only once.\n  - `Page event: :frame_navigated` - fired when the frame commits navigation\n    to a different URL.\n  - `Page event: :frame_detached` - fired when the frame gets detached from\n    the page.  A Frame can be detached from the page only once.","ref":"Playwright.Frame.html"},{"type":"function","title":"Playwright.Frame.check/3","doc":"","ref":"Playwright.Frame.html#check/3"},{"type":"function","title":"Playwright.Frame.click/3","doc":"Clicks an element matching `param: selector`, performing the following steps:\n\n  1. Find an element matching `param: selector`. If there is none, wait until\n    a matching element is attached to the DOM.\n  2. Wait for \"actionability (guide)\" checks on the matched element, unless\n    `option: force` option is set. If the element is detached during the\n    checks, the whole action is retried.\n  3. Scroll the element into view if needed.\n  4. Use `Playwright.Page.Mouse` to click the center of the element, or the\n    specified `option: position`.\n  5. Wait for initiated navigations to either succeed or fail, unless\n    `option: :no_wait_after` option is set.\n\nWhen all steps combined have not finished during the specified\n`option: timeout`, `/click/3` raises a `TimeoutError`. Passing zero for\n`option: timeout` disables this.","ref":"Playwright.Frame.html#click/3"},{"type":"function","title":"Playwright.Frame.dblclick/3","doc":"Double clicks an element matching selector.\n\nPerforms the following steps:\n\n  1. Find an element matching `param: selector`. If there is none, wait until\n    a matching element is attached to the DOM.\n  2. Wait for actionability checks on the matched element, unless\n    `option: force` is set. If the element is detached during the checks, the\n    whole action is retried.\n  3. Scroll the element into view if needed.\n  4. Use `Page.Mouse` to double click in the center of the element, or the\n    specified `option: position`.\n  5. Wait for initiated navigations to either succeed or fail, unless\n    `option: no_wait_after` is set. Note that if the first click of the\n    `dblclick/3` triggers a navigation event, the call will throw.\n\nWhen all steps combined have not finished during the specified\n`option: timeout`, throws a `TimeoutError`. Passing `timeout: 0` disables\nthis.\n\n> NOTE\n>\n> `dblclick/3` dispatches two `click` events and a single `dblclick` event.","ref":"Playwright.Frame.html#dblclick/3"},{"type":"function","title":"Returns - Playwright.Frame.dblclick/3","doc":"- `:ok`","ref":"Playwright.Frame.html#dblclick/3-returns"},{"type":"function","title":"Arguments - Playwright.Frame.dblclick/3","doc":"| key/name       | type   |                                   | description |\n| ---------------- | ------ | --------------------------------- | ----------- |\n| `selector`       | param  | `binary()`                        | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `:button`        | option | `:left`, `:right` or `:middle`    | `(default: :left)` |\n| `:delay`         | option | `number() `                       | Time to wait between keydown and keyup in milliseconds. `(default: 0)` |\n| `:force`         | option | `boolean()`                       | Whether to bypass the actionability checks. `(default: false)` |\n| `:modifiers`     | option | `[:alt, :control, :meta, :shift]` | Modifier keys to press. Ensures that only these modifiers are pressed during the operation, and then restores current modifiers back. If not specified, currently pressed modifiers are used. |\n| `:no_wait_after` | option | `boolean()`                       | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}`                   | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:strict`        | option | `boolean()`                       | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout`       | option | `number()`                        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`                       | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Frame.html#dblclick/3-arguments"},{"type":"function","title":"Playwright.Frame.dispatch_event/5","doc":"Dispatches the `param: type` event on the `param: selector` element.\n\nRegardless of the visibility state of the element, the event is dispatched.\n\nUnder the hood, creates an instance of an event based on the given type,\ninitializes it with the `param: event_init` properties and dispatches it on\nthe element.\n\nEvents are composed, cancelable and bubble by default.\n\nThe `param: event_init` is event-specific. Please refer to the events\ndocumentation for the lists of initial properties:\n\n- [DragEvent](https://developer.mozilla.org/en-US/docs/Web/API/DragEvent/DragEvent)\n- [FocusEvent](https://developer.mozilla.org/en-US/docs/Web/API/FocusEvent/FocusEvent)\n- [KeyboardEvent](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/KeyboardEvent)\n- [MouseEvent](https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent/MouseEvent)\n- [PointerEvent](https://developer.mozilla.org/en-US/docs/Web/API/PointerEvent/PointerEvent)\n- [TouchEvent](https://developer.mozilla.org/en-US/docs/Web/API/TouchEvent/TouchEvent)\n- [Event](https://developer.mozilla.org/en-US/docs/Web/API/Event/Event)","ref":"Playwright.Frame.html#dispatch_event/5"},{"type":"function","title":"Example - Playwright.Frame.dispatch_event/5","doc":"Dispatch a 'click' event on the element. This is equivalent to calling\n`Playwright.ElementHandle.click/2`:\n\n    Frame.dispatch_event(frame, \"button#submit\", :click)\n\nSpecify a `Playwright.JSHandle` as the property value to be passed into the\nevent:\n\n    data_transfer = Frame.evaluate_handle(frame, \"new DataTransfer()\")\n    Frame.dispatch_event(frame, \"#source\", :dragstart, { \"dataTransfer\": data_transfer })","ref":"Playwright.Frame.html#dispatch_event/5-example"},{"type":"function","title":"Returns - Playwright.Frame.dispatch_event/5","doc":"- `:ok`","ref":"Playwright.Frame.html#dispatch_event/5-returns"},{"type":"function","title":"Arguments - Playwright.Frame.dispatch_event/5","doc":"| key/name       | type   |                         | description |\n| ---------------- | ------ | ----------------------- | ----------- |\n| `selector`       | param  | `binary()`              | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `type`           | param  | `atom()` or `binary()`  | DOM event type: `:click`, `:dragstart`, etc. |\n| `event_init`     | param  | `evaluation_argument()` | Optional event-specific initialization properties. |\n| `:strict`        | option | `boolean()`             | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout`       | option | `number()`              | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Frame.html#dispatch_event/5-arguments"},{"type":"function","title":"Playwright.Frame.drag_and_drop/4","doc":"","ref":"Playwright.Frame.html#drag_and_drop/4"},{"type":"function","title":"Playwright.Frame.eval_on_selector/5","doc":"Returns the return value of `expression`.\n\n!!!","ref":"Playwright.Frame.html#eval_on_selector/5"},{"type":"function","title":"Playwright.Frame.eval_on_selector_all/4","doc":"","ref":"Playwright.Frame.html#eval_on_selector_all/4"},{"type":"function","title":"Playwright.Frame.evaluate/3","doc":"Returns the return value of `expression`.\n!!!","ref":"Playwright.Frame.html#evaluate/3"},{"type":"function","title":"Playwright.Frame.evaluate_handle/3","doc":"Returns the return value of `expression` as a `Playwright.JSHandle`.\n!!!","ref":"Playwright.Frame.html#evaluate_handle/3"},{"type":"function","title":"Playwright.Frame.fill/4","doc":"Fills a form field or `contenteditable` element with text.\n\nWaits for an element matching `param: selector`, waits for \"actionability\nchecks\", focuses the element, fills it and triggers an input event after\nfilling.\n\nIf the target element is not an ` `, ` ` or `contenteditable`\nelement, this function raises an error. However, if the element is inside the\n` ` element that has an associated control, the control will be filled\ninstead.\n\n> NOTE\n>\n> - Pass an empty string to clear the input field.\n> - To send fine-grained keyboard events, use `Playwright.Frame.type/4`.","ref":"Playwright.Frame.html#fill/4"},{"type":"function","title":"Returns - Playwright.Frame.fill/4","doc":"- `:ok`","ref":"Playwright.Frame.html#fill/4-returns"},{"type":"function","title":"Arguments - Playwright.Frame.fill/4","doc":"| key/name       | type   |                                   | description |\n| ---------------- | ------ | --------------------------------- | ----------- |\n| `selector`       | param  | `binary()`                        | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `value`          | param  | `binary()`                        | Value to fill for the ` `, ` ` or `[contenteditable]` element |\n| `:force`         | option | `boolean()`                       | Whether to bypass the actionability checks. `(default: false)` |\n| `:no_wait_after` | option | `boolean()`                       | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:strict`        | option | `boolean()`                       | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout`       | option | `number()`                        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Frame.html#fill/4-arguments"},{"type":"function","title":"Playwright.Frame.focus/3","doc":"Fetches an element with `param: selector` and focuses it.\n\nIf no element matches the selector, waits until a matching element appears in the DOM.","ref":"Playwright.Frame.html#focus/3"},{"type":"function","title":"Returns - Playwright.Frame.focus/3","doc":"- `:ok`","ref":"Playwright.Frame.html#focus/3-returns"},{"type":"function","title":"Arguments - Playwright.Frame.focus/3","doc":"| key/name | type   |             | description |\n| ---------- | ------ | ----------- | ----------- |\n| `selector` | param  | `binary()`  | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `:strict`  | option | `boolean()` | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout` | option | `number()`  | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Frame.html#focus/3-arguments"},{"type":"function","title":"Playwright.Frame.get_attribute/4","doc":"Returns element attribute value.\n!!!","ref":"Playwright.Frame.html#get_attribute/4"},{"type":"function","title":"Playwright.Frame.get_by_text/3","doc":"Allows locating elements that contain given text.","ref":"Playwright.Frame.html#get_by_text/3"},{"type":"function","title":"Arguments - Playwright.Frame.get_by_text/3","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `text`     | param  | `binary()` | Text to locate the element for. |\n| `:exact`   | option | `boolean()`| Whether to find an exact match: case-sensitive and whole-string. Default to false. Ignored when locating by a regular expression. Note that exact match still trims whitespace. |","ref":"Playwright.Frame.html#get_by_text/3-arguments"},{"type":"function","title":"Playwright.Frame.goto/3","doc":"!!!","ref":"Playwright.Frame.html#goto/3"},{"type":"function","title":"Playwright.Frame.hover/3","doc":"Hovers over an element matching `param: selector`.\n\nPerforms the following steps:\n\n1. Find an element matching `param: selector`. If there is none, wait until\n  a matching element is attached to the DOM.\n2. Wait for actionability checks on the matched element, unless\n  `option: force` option is set. If the element is detached during the checks,\n  the whole action is retried.\n3. Scroll the element into view if needed.\n4. Use `Page.Mouse` to hover over the center of the element, or the specified\n  `option: position`.\n5. Wait for initiated navigations to either succeed or fail, unless\n  `option: no_wait_after` is set.\n\nWhen all steps combined have not finished during the specified `option: timeout`,\nthrows a `TimeoutError`. Passing `0` timeout disables this.","ref":"Playwright.Frame.html#hover/3"},{"type":"function","title":"Returns - Playwright.Frame.hover/3","doc":"- `:ok`","ref":"Playwright.Frame.html#hover/3-returns"},{"type":"function","title":"Arguments - Playwright.Frame.hover/3","doc":"| key/name       | type   |                                   | description |\n| ---------------- | ------ | --------------------------------- | ----------- |\n| `selector`       | param  | `binary()`                        | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `:force`         | option | `boolean()`                       | Whether to bypass the actionability checks. `(default: false)` |\n| `:modifiers`     | option | `[:alt, :control, :meta, :shift]` | Modifier keys to press. Ensures that only these modifiers are pressed during the operation, and then restores current modifiers back. If not specified, currently pressed modifiers are used. |\n| `:no_wait_after` | option | `boolean()`                       | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}`                   | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:strict`        | option | `boolean()`                       | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout`       | option | `number()`                        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`                       | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Frame.html#hover/3-arguments"},{"type":"function","title":"Playwright.Frame.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Frame.html#init/2"},{"type":"function","title":"Example - Playwright.Frame.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Frame.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Frame.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Frame.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Frame.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Frame.html#init/2-arguments"},{"type":"function","title":"Playwright.Frame.inner_html/3","doc":"","ref":"Playwright.Frame.html#inner_html/3"},{"type":"function","title":"Playwright.Frame.inner_text/3","doc":"","ref":"Playwright.Frame.html#inner_text/3"},{"type":"function","title":"Playwright.Frame.input_value/3","doc":"","ref":"Playwright.Frame.html#input_value/3"},{"type":"function","title":"Playwright.Frame.is_checked/3","doc":"","ref":"Playwright.Frame.html#is_checked/3"},{"type":"function","title":"Playwright.Frame.is_disabled/3","doc":"","ref":"Playwright.Frame.html#is_disabled/3"},{"type":"function","title":"Playwright.Frame.is_editable/3","doc":"","ref":"Playwright.Frame.html#is_editable/3"},{"type":"function","title":"Playwright.Frame.is_enabled/3","doc":"","ref":"Playwright.Frame.html#is_enabled/3"},{"type":"function","title":"Playwright.Frame.is_hidden/3","doc":"","ref":"Playwright.Frame.html#is_hidden/3"},{"type":"function","title":"Playwright.Frame.is_visible/3","doc":"","ref":"Playwright.Frame.html#is_visible/3"},{"type":"function","title":"Playwright.Frame.locator/2","doc":"","ref":"Playwright.Frame.html#locator/2"},{"type":"function","title":"Playwright.Frame.press/4","doc":"`param: key` can specify the intended [`keyboardEvent.key`](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key)\nvalue or a single character for which to generate the text.\n\nA superset of the\n`param: key` values can be found on [MDN](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values).\n\nExamples of the keys are:\n\n`F1` - `F12`, `Digit0`- `Digit9`, `KeyA`- `KeyZ`, `Backquote`, `Minus`,\n`Equal`, `Backslash`, `Backspace`, `Tab`, `Delete`, `Escape`, `ArrowDown`,\n`End`, `Enter`, `Home`, `Insert`, `PageDown`, `PageUp`, `ArrowRight`,\n`ArrowUp`, etc.\n\nThe following modification shortcuts are also supported: `Shift`, `Control`,\n`Alt`, `Meta`, `ShiftLeft`.\n\nHolding down `Shift` will type the text that corresponds to the `param: key`\nin the upper case.\n\nIf `param: key` is a single character, it is case-sensitive, so the values\n`a` and `A` will generate different respective texts.\n\nShortcuts such as `key: \"Control+o\"` or `key: \"Control+Shift+T\"` are\nsupported as well. When specified with the modifier, modifier is pressed\nand being held while the subsequent key is being pressed.","ref":"Playwright.Frame.html#press/4"},{"type":"function","title":"Returns - Playwright.Frame.press/4","doc":"- :ok","ref":"Playwright.Frame.html#press/4-returns"},{"type":"function","title":"Arguments - Playwright.Frame.press/4","doc":"| key/name       | type   |              | description |\n| ---------------- | ------ | ------------ | ----------- |\n| `selector`       | param  | `binary()`   | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `key`            | param  | `binary()`   | Name of the key to press or a character to generate, such as `ArrowLeft` or `a`. |\n| `:delay`         | option | `number() `  | Time to wait between keydown and keyup in milliseconds. `(default: 0)` |\n| `:no_wait_after` | option | `boolean()`  | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:strict`        | option | `boolean()`  | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout`       | option | `number()`   | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Frame.html#press/4-arguments"},{"type":"function","title":"Playwright.Frame.q/3","doc":"","ref":"Playwright.Frame.html#q/3"},{"type":"function","title":"Playwright.Frame.qq/3","doc":"","ref":"Playwright.Frame.html#qq/3"},{"type":"function","title":"Playwright.Frame.query_selector/3","doc":"Returns the `Playwright.ElementHandle` pointing to the frame element.\n\nThe function finds an element matching the specified selector within the\nframe. See \"working with selectors (guide)\" for more details. If no elements\nmatch the selector, returns `nil`.","ref":"Playwright.Frame.html#query_selector/3"},{"type":"function","title":"Returns - Playwright.Frame.query_selector/3","doc":"- `Playwright.ElementHandle.t()`\n  - `nil`","ref":"Playwright.Frame.html#query_selector/3-returns"},{"type":"function","title":"Arguments - Playwright.Frame.query_selector/3","doc":"| key/name | type   |             | description |\n| ---------- | ------ | ----------- | ----------- |\n| `selector` | param  | `binary()`  | A selector to query for. See \"working with selectors (guide)\" for more details. |\n| `strict`   | option | `boolean()` | When true, the call requires `selector` to resolve to a single element. If the given `selector` resolves to more then one element, the call raises an error. |","ref":"Playwright.Frame.html#query_selector/3-arguments"},{"type":"function","title":"Playwright.Frame.query_selector_all/3","doc":"Returns the list of `Playwright.ElementHandle` pointing to the frame elements.\n\nThe method finds all elements matching the specified selector within the\nframe. See \"working with selectors (guide)\" for more details.\n\nIf no elements match the selector, returns an empty `List`.","ref":"Playwright.Frame.html#query_selector_all/3"},{"type":"function","title":"Returns - Playwright.Frame.query_selector_all/3","doc":"- `[Playwright.ElementHandle.t()]`","ref":"Playwright.Frame.html#query_selector_all/3-returns"},{"type":"function","title":"Arguments - Playwright.Frame.query_selector_all/3","doc":"| key/name | type   |             | description |\n| ---------- | ------ | ----------- | ----------- |\n| `selector` | param  | `binary()`  | A selector to query for. See \"working with selectors (guide)\" for more details. |","ref":"Playwright.Frame.html#query_selector_all/3-arguments"},{"type":"function","title":"Playwright.Frame.select_option/4","doc":"Selects one or more options from a ` ` element.\n\nPerforms the following steps:\n\n1. Waits for an element matching `param: selector`\n2. Waits for actionability checks\n3. Waits until all specified options are present in the ` ` element\n4. Selects those options\n\nIf the target element is not a ` ` element, raises an error. However,\nif the element is inside the ` ` element that has an associated control,\nthe control will be used instead.\n\nReturns the list of option values that have been successfully selected.\n\nTriggers a change and input event once all the provided options have been selected.","ref":"Playwright.Frame.html#select_option/4"},{"type":"function","title":"Example - Playwright.Frame.select_option/4","doc":"# single selection matching the value\n    Frame.select_option(frame, \"select#colors\", \"blue\")\n\n    # single selection matching both the label\n    Frame.select_option(frame, \"select#colors\", %{label: \"blue\"})\n\n    # multiple selection\n    Frame.select_option(frame, \"select#colors\", %{value: [\"red\", \"green\", \"blue\"]})","ref":"Playwright.Frame.html#select_option/4-example"},{"type":"function","title":"Returns - Playwright.Frame.select_option/4","doc":"- `[binary()]`","ref":"Playwright.Frame.html#select_option/4-returns"},{"type":"function","title":"Arguments - Playwright.Frame.select_option/4","doc":"| key/name       | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `selector`       | param  | `binary()`      | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `values`         | param  | `any()`         | Options to select. |\n| `:force`         | option | `boolean()`     | Whether to bypass the actionability checks. `(default: false)` |\n| `:no_wait_after` | option | `boolean()`     | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:strict`        | option | `boolean()`     | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Frame.html#select_option/4-arguments"},{"type":"function","title":"On `values` - Playwright.Frame.select_option/4","doc":"If the ` ` has the `multiple` attribute, all matching options are\nselected, otherwise only the first option matching one of the passed options\nis selected.\n\nString values are equivalent to `%{value: \"string\"}`.\n\nOption is considered matching if all specified properties match.\n\n- `value  ` Matches by `option.value`. `(optional)`.\n- `label  ` Matches by `option.label`. `(optional)`.\n- `index  ` Matches by the index. `(optional)`.","ref":"Playwright.Frame.html#select_option/4-on-values"},{"type":"function","title":"Playwright.Frame.set_content/3","doc":"","ref":"Playwright.Frame.html#set_content/3"},{"type":"function","title":"Returns - Playwright.Frame.set_content/3","doc":"- `:ok`","ref":"Playwright.Frame.html#set_content/3-returns"},{"type":"function","title":"Arguments - Playwright.Frame.set_content/3","doc":"| key/name | type   |             | description |\n| ---------- | ------ | ----------- | ----------- |\n| `html`     | param  | `binary()`  | HTML markup to assign to the page. |\n| `:timeout` | option | `number()`  | Maximum operation time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_navigation_timeout/2`, `Playwright.BrowserContext.set_default_timeout/2`, `Playwright.Page.set_default_navigation_timeout/2` or `Playwright.Page.set_default_timeout/` functions. `(default: 30 seconds)` |","ref":"Playwright.Frame.html#set_content/3-arguments"},{"type":"function","title":"Playwright.Frame.set_input_files/4","doc":"","ref":"Playwright.Frame.html#set_input_files/4"},{"type":"function","title":"Playwright.Frame.tap/3","doc":"","ref":"Playwright.Frame.html#tap/3"},{"type":"function","title":"Playwright.Frame.text_content/3","doc":"Returns `Playwright.ElementHandle.text_content/1`","ref":"Playwright.Frame.html#text_content/3"},{"type":"function","title":"Returns - Playwright.Frame.text_content/3","doc":"- `binary() | nil`","ref":"Playwright.Frame.html#text_content/3-returns"},{"type":"function","title":"Arguments - Playwright.Frame.text_content/3","doc":"| key/name | type   |             | description |\n| ---------- | ------ | ----------- | ----------- |\n| `selector` | param  | `binary()`  | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `:strict`  | option | `boolean()` | When true, the call requires selector to resolve to a single element. If given selector resolves to more then one element, the call throws an exception. |\n| `:timeout` | option | `number()`  | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Frame.html#text_content/3-arguments"},{"type":"function","title":"Playwright.Frame.title/1","doc":"Returns the page title.","ref":"Playwright.Frame.html#title/1"},{"type":"function","title":"Returns - Playwright.Frame.title/1","doc":"- `binary()`","ref":"Playwright.Frame.html#title/1-returns"},{"type":"function","title":"Playwright.Frame.type/4","doc":"","ref":"Playwright.Frame.html#type/4"},{"type":"function","title":"Playwright.Frame.uncheck/3","doc":"","ref":"Playwright.Frame.html#uncheck/3"},{"type":"function","title":"Playwright.Frame.wait_for_load_state/3","doc":"Waits for the required load state to be reached.\n\nThis returns when the frame reaches a required load state, \"load\" by default.\nThe navigation must have been committed when this method is called. If\nthe current document has already reached the required state, resolves\nimmediately.","ref":"Playwright.Frame.html#wait_for_load_state/3"},{"type":"function","title":"Playwright.Frame.wait_for_selector/3","doc":"Returns when element specified by selector satisfies state option.\n\nFIXME: the following is NOT TRUE... Returns `nil` if waiting for a hidden or detached element.","ref":"Playwright.Frame.html#wait_for_selector/3"},{"type":"type","title":"Playwright.Frame.evaluation_argument/0","doc":"","ref":"Playwright.Frame.html#t:evaluation_argument/0"},{"type":"type","title":"Playwright.Frame.expression/0","doc":"","ref":"Playwright.Frame.html#t:expression/0"},{"type":"type","title":"Playwright.Frame.load_state/0","doc":"","ref":"Playwright.Frame.html#t:load_state/0"},{"type":"type","title":"Playwright.Frame.options/0","doc":"","ref":"Playwright.Frame.html#t:options/0"},{"type":"type","title":"Playwright.Frame.serializable/0","doc":"","ref":"Playwright.Frame.html#t:serializable/0"},{"type":"type","title":"Playwright.Frame.t/0","doc":"%Playwright.Frame{}","ref":"Playwright.Frame.html#t:t/0"},{"type":"module","title":"Playwright.JSHandle","doc":"`Playwright.JSHandle` represents an in-page JavaScript object. `JSHandles`\ncan be created with `Playwright.Page.evaluate_handle/3`.","ref":"Playwright.JSHandle.html"},{"type":"module","title":"Example - Playwright.JSHandle","doc":"handle = Page.evaluate_handle(page, \"() => window\")\n\n`JSHandle` prevents the referenced JavaScript object from being garbage\ncollected unless the handle is disposed with `Playwright.JSHandle.dispose/1`.\n`JSHandles` are auto-disposed when their origin frame gets navigated or the\nparent context gets destroyed.\n\n`JSHandle` instances can be used as arguments to:\n\n  - `Playwright.Page.eval_on_selector/5`\n  - `Playwright.Page.evaluate/3`\n  - `Playwright.Page.evaluate_handle/3`","ref":"Playwright.JSHandle.html#module-example"},{"type":"function","title":"Playwright.JSHandle.as_element/1","doc":"Returns either `nil` or the object handle itself, if the object handle is an instance of `Playwright.ElementHandle`.","ref":"Playwright.JSHandle.html#as_element/1"},{"type":"function","title":"Playwright.JSHandle.evaluate/3","doc":"","ref":"Playwright.JSHandle.html#evaluate/3"},{"type":"function","title":"Playwright.JSHandle.evaluate_handle/3","doc":"Returns the return value from executing `param: expression` in the browser as\na `Playwright.JSHandle`.\n\nThis function passes the handle as the first argument to `param: expression`.\n\nThe only difference between `Playwright.JSHandle.evaluate/3` and\n`Playwright.JSHandle.evaluate_handle/3` is that `evaluate_handle` returns\n`Playwright.JSHandle`.\n\nIf the expression passed to `Playwright.JSHandle.evaluate_handle/3` returns\na `Promise`, `Playwright.JSHandle.evaluate_handle/3` waits for the promise to\nresolve and return its value.\n\nSee `Playwright.Page.evaluate_handle/3` for more details.","ref":"Playwright.JSHandle.html#evaluate_handle/3"},{"type":"function","title":"Returns - Playwright.JSHandle.evaluate_handle/3","doc":"- `Playwright.ElementHandle.t()`","ref":"Playwright.JSHandle.html#evaluate_handle/3-returns"},{"type":"function","title":"Arguments - Playwright.JSHandle.evaluate_handle/3","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `expression`  | param  | `binary()` | Function to be evaluated in the page context. |\n| `arg`         | param  | `any()`    | Argument to pass to `expression` `(optional)` |","ref":"Playwright.JSHandle.html#evaluate_handle/3-arguments"},{"type":"function","title":"Playwright.JSHandle.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.JSHandle.html#init/2"},{"type":"function","title":"Example - Playwright.JSHandle.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.JSHandle.html#init/2-example"},{"type":"function","title":"Returns - Playwright.JSHandle.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.JSHandle.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.JSHandle.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.JSHandle.html#init/2-arguments"},{"type":"function","title":"Playwright.JSHandle.string/1","doc":"","ref":"Playwright.JSHandle.html#string/1"},{"type":"type","title":"Playwright.JSHandle.t/0","doc":"%Playwright.JSHandle{}","ref":"Playwright.JSHandle.html#t:t/0"},{"type":"module","title":"Playwright.Locator","doc":"Locators are the central piece of Playwright's auto-waiting and retry-ability.\nIn a nutshell, locators represent a way to find element(s) on the page at any\nmoment. A locator may be created with the `Page.locator/2` function.\n\nInstances of `Playwright.Locator` may be created via the following means:\n\n- `Playwright.Locator.new/2`\n- `Playwright.Frame.locator/2`\n- `Playwright.Page.locator/2`\n\n[Learn more about locators](guides-locators.html).","ref":"Playwright.Locator.html"},{"type":"function","title":"Playwright.Locator.all/1","doc":"When the locator points to a list of elements, returns a list of locators,\neach addressing their respective elements.\n\n>","ref":"Playwright.Locator.html#all/1"},{"type":"function","title":"NOTE {: .warning} - Playwright.Locator.all/1","doc":">\n> `Playwright.Locator.all/1` does not wait for elements to match the locator,\n> and instead immediately returns whatever is present in the page. When the\n> list of elements changes dynamically, `Playwright.Locator.all/1` will\n> produce unpredictable and flaky results. When the list of elements is\n> stable, but loaded dynamically, wait for the full list to finish loading\n> before calling `Playwright.Locator.all/1``.","ref":"Playwright.Locator.html#all/1-note-warning"},{"type":"function","title":"Returns - Playwright.Locator.all/1","doc":"- `[Playwright.Locator]`","ref":"Playwright.Locator.html#all/1-returns"},{"type":"function","title":"Example - Playwright.Locator.all/1","doc":"Retrieve the text for all ` ` elements currently on the page:\n\n    Playwright.Page.locator(page, \"p\")\n    |> Playwright.Locator.all()\n    |> Enum.map(fn locator -> Playwright.Locator.text_content(locator) end)","ref":"Playwright.Locator.html#all/1-example"},{"type":"function","title":"Playwright.Locator.all_inner_texts/1","doc":"Returns an list of `node.innerText` values for all matching nodes.","ref":"Playwright.Locator.html#all_inner_texts/1"},{"type":"function","title":"Returns - Playwright.Locator.all_inner_texts/1","doc":"- `[binary()]`","ref":"Playwright.Locator.html#all_inner_texts/1-returns"},{"type":"function","title":"Example - Playwright.Locator.all_inner_texts/1","doc":"Retrieve the text for all ` ` elements currently on the page:\n\n    Playwright.Page.locator(page, \"p\")\n    |> Playwright.Locator.all_inner_texts()","ref":"Playwright.Locator.html#all_inner_texts/1-example"},{"type":"function","title":"Playwright.Locator.all_text_contents/1","doc":"Returns an list of `node.textContent` values for all matching nodes.","ref":"Playwright.Locator.html#all_text_contents/1"},{"type":"function","title":"Returns - Playwright.Locator.all_text_contents/1","doc":"- `[binary()]`","ref":"Playwright.Locator.html#all_text_contents/1-returns"},{"type":"function","title":"Example - Playwright.Locator.all_text_contents/1","doc":"Retrieve the text for all ` ` elements currently on the page:\n\n    Playwright.Page.locator(page, \"p\")\n    |> Playwright.Locator.all_text_contents()","ref":"Playwright.Locator.html#all_text_contents/1-example"},{"type":"function","title":"Playwright.Locator.blur/2","doc":"","ref":"Playwright.Locator.html#blur/2"},{"type":"function","title":"Playwright.Locator.bounding_box/2","doc":"Returns the bounding box of the element, or `nil` if the element is not visible.\n\nThe bounding box is calculated relative to the main frame viewport which is\nusually the same as the browser window.\n\nScrolling affects the returned bounding box, similarly to\n[Element.getBoundingClientRect](https://developer.mozilla.org/en-US/docs/Web/API/Element/getBoundingClientRect).\n\nThat means `x` and/or `y` may be negative.\n\nElements from child frames return the bounding box relative to the main frame,\nunlike [Element.getBoundingClientRect](https://developer.mozilla.org/en-US/docs/Web/API/Element/getBoundingClientRect).\n\nAssuming the page is static, it is safe to use bounding box coordinates to perform input. For example, the following snippet should click the center of the element:options()\n\n    box = Locator.bounding_box(locator)\n    Page.Mouse.click(page, box.x + box.width / 2, box.y + box.height / 2)","ref":"Playwright.Locator.html#bounding_box/2"},{"type":"function","title":"Returns - Playwright.Locator.bounding_box/2","doc":"- `%{x: x, y: y, width: width, height: height}`\n  - `nil`","ref":"Playwright.Locator.html#bounding_box/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.bounding_box/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#bounding_box/2-arguments"},{"type":"function","title":"Playwright.Locator.check/2","doc":"Checks the (checkmark) element by performing the following steps:\n\n  1. Ensure that element is a checkbox or a radio input. If not, this method\n    throws. If the element is already checked, this method returns immediately.\n  2. Wait for actionability checks on the element, unless force option is set.\n  3. Scroll the element into view if needed.\n  4. Use `Playwright.Page.Mouse` to click in the center of the element.\n  5. Wait for initiated navigations to either succeed or fail, unless\n    `option: no_wait_after` is set.\n  6. Ensure that the element is now checked. If not, this method throws.\n\nIf the element is detached from the DOM at any moment during the action,\nthis method throws.\n\nWhen all steps combined have not finished during the specified timeout, this\nmethod throws a `TimeoutError`. Passing `0` timeout disables this.","ref":"Playwright.Locator.html#check/2"},{"type":"function","title":"Returns - Playwright.Locator.check/2","doc":"- `:ok`","ref":"Playwright.Locator.html#check/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.check/2","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `:force`         | option | `boolean()`     | Whether to bypass the actionability checks. `(default: false)` |\n| `:no_wait_after` | option | `boolean()`     | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}` | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`     | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Locator.html#check/2-arguments"},{"type":"function","title":"Playwright.Locator.clear/2","doc":"Clears the contents of a form input/textarea field.","ref":"Playwright.Locator.html#clear/2"},{"type":"function","title":"Playwright.Locator.click/2","doc":"Clicks the element by performing the following steps:\n\n1. Wait for actionability checks on the element, unless `option: force` is set.\n2. Scroll the element into view if needed.\n3. Use `Playwright.Page.Mouse` to click in the center of the element, or\n   the specified position.\n4. Wait for initiated navigations to either succeed or fail, unless\n   `option: no_wait_after` is set.\n\nIf the element is detached from the DOM at any moment during the action, this method throws.\n\nWhen all steps combined have not finished during the specified timeout, this method throws a\n`Playwright.SDK.Channel.Error.t()`. Passing `0` timeout disables this.","ref":"Playwright.Locator.html#click/2"},{"type":"function","title":"Returns - Playwright.Locator.click/2","doc":"- `:ok`","ref":"Playwright.Locator.html#click/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.click/2","doc":"| key/name         | type   |                                   | description |\n| ---------------- | ------ | --------------------------------- | ----------- |\n| `:button`        | option | `:left`, `:right` or `:middle`    | `(default: :left)` |\n| `:click_count`   | option | `number()`                        | See [MDN: `UIEvent.detail`](https://developer.mozilla.org/en-US/docs/Web/API/UIEvent/detail) `(default: 1)` |\n| `:delay`         | option | `number()`                        | Time to wait between `mousedown` and `mouseup` in milliseconds. `(default: 0)` |\n| `:force`         | option | `boolean()`                       | Whether to bypass the actionability checks. `(default: false)` |\n| `:modifiers`     | option | `[:alt, :control, :meta, :shift]` | Modifier keys to press. Ensures that only these modifiers are pressed during the operation, and then restores current modifiers back. If not specified, currently pressed modifiers are used. |\n| `:no_wait_after` | option | `boolean()`                       | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}`                   | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:timeout`       | option | `number()`                        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`                       | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Locator.html#click/2-arguments"},{"type":"function","title":"Playwright.Locator.count/1","doc":"Returns the number of elements matching given selector.","ref":"Playwright.Locator.html#count/1"},{"type":"function","title":"Returns - Playwright.Locator.count/1","doc":"- `number()`","ref":"Playwright.Locator.html#count/1-returns"},{"type":"function","title":"Playwright.Locator.dblclick/2","doc":"Double clicks the element.\n\nPerforms the following steps:\n\n  1. Wait for actionability checks on the matched element, unless\n    `option: force` is set.\n  2. Scroll the element into view if needed.\n  3 Use `Page.Mouse` to double click in the center of the element, or the\n    specified `option: position`.\n  4. Wait for initiated navigations to either succeed or fail, unless\n    `option: no_wait_after` is set. Note that if the first click of the\n    `dblclick/3` triggers a navigation event, the call will throw.\n\nIf the element is detached from the DOM at any moment during the action,\nthe call throws.\n\nWhen all steps combined have not finished during the specified\n`option: timeout`, throws a `TimeoutError`. Passing `timeout: 0` disables\nthis.\n\n> NOTE\n>\n> `dblclick/3` dispatches two `click` events and a single `dblclick` event.","ref":"Playwright.Locator.html#dblclick/2"},{"type":"function","title":"Returns - Playwright.Locator.dblclick/2","doc":"- `:ok`","ref":"Playwright.Locator.html#dblclick/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.dblclick/2","doc":"| key/name         | type   |                                   | description |\n| ---------------- | ------ | --------------------------------- | ----------- |\n| `:button`        | option | `:left`, `:right` or `:middle`    | `(default: :left)` |\n| `:delay`         | option | `number() `                       | Time to wait between keydown and keyup in milliseconds. `(default: 0)` |\n| `:force`         | option | `boolean()`                       | Whether to bypass the actionability checks. `(default: false)` |\n| `:modifiers`     | option | `[:alt, :control, :meta, :shift]` | Modifier keys to press. Ensures that only these modifiers are pressed during the operation, and then restores current modifiers back. If not specified, currently pressed modifiers are used. |\n| `:no_wait_after` | option | `boolean()`                       | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}`                   | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:timeout`       | option | `number()`                        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`                       | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Locator.html#dblclick/2-arguments"},{"type":"function","title":"Playwright.Locator.dispatch_event/4","doc":"Dispatches the `param: type` event on the element.\n\nRegardless of the visibility state of the element, the event is dispatched.\n\nUnder the hood, creates an instance of an event based on the given type,\ninitializes it with the `param: event_init` properties and dispatches it on\nthe element.\n\nEvents are composed, cancelable and bubble by default.\n\nThe `param: event_init` is event-specific. Please refer to the events\ndocumentation for the lists of initial properties:\n\n- [DragEvent](https://developer.mozilla.org/en-US/docs/Web/API/DragEvent/DragEvent)\n- [FocusEvent](https://developer.mozilla.org/en-US/docs/Web/API/FocusEvent/FocusEvent)\n- [KeyboardEvent](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/KeyboardEvent)\n- [MouseEvent](https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent/MouseEvent)\n- [PointerEvent](https://developer.mozilla.org/en-US/docs/Web/API/PointerEvent/PointerEvent)\n- [TouchEvent](https://developer.mozilla.org/en-US/docs/Web/API/TouchEvent/TouchEvent)\n- [Event](https://developer.mozilla.org/en-US/docs/Web/API/Event/Event)","ref":"Playwright.Locator.html#dispatch_event/4"},{"type":"function","title":"Example - Playwright.Locator.dispatch_event/4","doc":"Dispatch a 'click' event on the element. This is equivalent to calling\n`Playwright.ElementHandle.click/2`:\n\n    Locator.dispatch_event(locator, :click)\n\nSpecify a `Playwright.JSHandle` as the property value to be passed into the\nevent:\n\n    data_transfer = Page.evaluate_handle(page, \"new DataTransfer()\")\n    Locator.dispatch_event(locator, :dragstart, { \"dataTransfer\": data_transfer })","ref":"Playwright.Locator.html#dispatch_event/4-example"},{"type":"function","title":"Returns - Playwright.Locator.dispatch_event/4","doc":"- `:ok`","ref":"Playwright.Locator.html#dispatch_event/4-returns"},{"type":"function","title":"Arguments - Playwright.Locator.dispatch_event/4","doc":"| key/name         | type   |                         | description |\n| ---------------- | ------ | ----------------------- | ----------- |\n| `type`           | param  | `atom()` or `binary()`  | DOM event type: `:click`, `:dragstart`, etc. |\n| `event_init`     | param  | `evaluation_argument()` | Optional event-specific initialization properties. |\n| `:timeout`       | option | `number()`              | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#dispatch_event/4-arguments"},{"type":"function","title":"Playwright.Locator.drag_to/3","doc":"","ref":"Playwright.Locator.html#drag_to/3"},{"type":"function","title":"Playwright.Locator.element_handle/2","doc":"Resolves the given `Playwright.Locator` to the first matching DOM element.\n\nIf no elements matching the query are visible, waits for them up to a given\ntimeout. If multiple elements match the selector, throws.","ref":"Playwright.Locator.html#element_handle/2"},{"type":"function","title":"Returns - Playwright.Locator.element_handle/2","doc":"- `Playwright.ElementHandle.t()`\n- `{:error, Playwright.SDK.Channel.Error.t()}`","ref":"Playwright.Locator.html#element_handle/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.element_handle/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#element_handle/2-arguments"},{"type":"function","title":"Playwright.Locator.element_handles/1","doc":"Resolves given locator to all matching DOM elements.","ref":"Playwright.Locator.html#element_handles/1"},{"type":"function","title":"Returns - Playwright.Locator.element_handles/1","doc":"- `[Playwright.ElementHandle.t()]`","ref":"Playwright.Locator.html#element_handles/1-returns"},{"type":"function","title":"Playwright.Locator.evaluate/4","doc":"Returns the result of executing `param: expression`.\n\nPasses the handle as the first argument to the expression.","ref":"Playwright.Locator.html#evaluate/4"},{"type":"function","title":"Returns - Playwright.Locator.evaluate/4","doc":"- `Serializable.t()`","ref":"Playwright.Locator.html#evaluate/4-returns"},{"type":"function","title":"Arguments - Playwright.Locator.evaluate/4","doc":"| key/name     | type   |            | description |\n| ------------ | ------ | ---------- | ----------- |\n| `expression` | param  | `binary()` | JavaScript expression to be evaluated in the browser context. If it looks like a function declaration, it is interpreted as a function. Otherwise, evaluated as an expression. |\n| `arg`        | param  | `any()`    | Argument to pass to `expression` `(optional)` |\n| `:timeout`   | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#evaluate/4-arguments"},{"type":"function","title":"Playwright.Locator.evaluate_all/3","doc":"Finds all elements matching the specified locator and passes the list of\nmatched elements as an argument to `param: expression`.\n\nReturns the result of expression invocation.","ref":"Playwright.Locator.html#evaluate_all/3"},{"type":"function","title":"Returns - Playwright.Locator.evaluate_all/3","doc":"- `Serializable.t()`","ref":"Playwright.Locator.html#evaluate_all/3-returns"},{"type":"function","title":"Arguments - Playwright.Locator.evaluate_all/3","doc":"| key/name   | type   |            | description |\n| ------------ | ------ | ---------- | ----------- |\n| `expression` | param  | `binary()` | JavaScript expression to be evaluated in the browser context. If it looks like a function declaration, it is interpreted as a function. Otherwise, evaluated as an expression. |\n| `arg`        | param  | `any()`    | Argument to pass to `expression` `(optional)` |","ref":"Playwright.Locator.html#evaluate_all/3-arguments"},{"type":"function","title":"Playwright.Locator.evaluate_handle/4","doc":"Returns the result of `param: expression` as a `Playwright.JSHandle`.\n\nPasses the handle as the first argument to `param: expression`.\n\nThe only difference between `Playwright.Locator.evaluate/4` and\n`Playwright.Locator.evaluate_handle/3` is that `evaluate_handle` returns\n`JSHandle`.\n\nSee `Playwright.Page.evaluate_handle` for more details.","ref":"Playwright.Locator.html#evaluate_handle/4"},{"type":"function","title":"Returns - Playwright.Locator.evaluate_handle/4","doc":"- `Playwright.ElementHandle.t()`\n  - `{:error, Playwright.SDK.Channel.Error.t()}`","ref":"Playwright.Locator.html#evaluate_handle/4-returns"},{"type":"function","title":"Arguments - Playwright.Locator.evaluate_handle/4","doc":"| key/name     | type   |            | description |\n| ------------ | ------ | ---------- | ----------- |\n| `expression` | param  | `binary()` | JavaScript expression to be evaluated in the browser context. If it looks like a function declaration, it is interpreted as a function. Otherwise, evaluated as an expression. |\n| `arg`        | param  | `any()`    | Argument to pass to `expression` `(optional)` |\n| `:timeout`   | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#evaluate_handle/4-arguments"},{"type":"function","title":"Playwright.Locator.fill/3","doc":"Fills a form field or `contenteditable` element with text.\n\nWaits for an element matching `param: selector`, waits for \"actionability\nchecks\", focuses the element, fills it and triggers an input event after\nfilling.\n\nIf the target element is not an ` `, ` ` or `contenteditable`\nelement, this function raises an error. However, if the element is inside the\n` ` element that has an associated control, the control will be filled\ninstead.\n\n> NOTE\n>\n> - Pass an empty string to clear the input field.\n> - To send fine-grained keyboard events, use `Playwright.Locator.type/3`.","ref":"Playwright.Locator.html#fill/3"},{"type":"function","title":"Returns - Playwright.Locator.fill/3","doc":"- `:ok`","ref":"Playwright.Locator.html#fill/3-returns"},{"type":"function","title":"Arguments - Playwright.Locator.fill/3","doc":"| key/name         | type   |             | description |\n| ---------------- | ------ | ----------- | ----------- |\n| `value`          | param  | `binary()`  | Value to fill for the ` `, ` ` or `[contenteditable]` element |\n| `:force`         | option | `boolean()` | Whether to bypass the actionability checks. `(default: false)` |\n| `:no_wait_after` | option | `boolean()` | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:timeout`       | option | `number()`  | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#fill/3-arguments"},{"type":"function","title":"Playwright.Locator.first/1","doc":"Returns a new `Playwright.Locator` scoped to the first matching element.","ref":"Playwright.Locator.html#first/1"},{"type":"function","title":"Playwright.Locator.focus/2","doc":"Calls [focus](https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement/focus) on the element.","ref":"Playwright.Locator.html#focus/2"},{"type":"function","title":"Returns - Playwright.Locator.focus/2","doc":"- `:ok`","ref":"Playwright.Locator.html#focus/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.focus/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#focus/2-arguments"},{"type":"function","title":"Playwright.Locator.get_attribute/3","doc":"Returns element attribute value.","ref":"Playwright.Locator.html#get_attribute/3"},{"type":"function","title":"Arguments - Playwright.Locator.get_attribute/3","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `name`     | param  | `binary()` | Name of the attribute to retrieve. |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#get_attribute/3-arguments"},{"type":"function","title":"Playwright.Locator.get_by_text/3","doc":"Allows locating elements that contain given text.","ref":"Playwright.Locator.html#get_by_text/3"},{"type":"function","title":"Arguments - Playwright.Locator.get_by_text/3","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `text`     | param  | `binary()` | Text to locate the element for. |\n| `:exact`   | option | `boolean()`| Whether to find an exact match: case-sensitive and whole-string. Default to false. Ignored when locating by a regular expression. Note that exact match still trims whitespace. |","ref":"Playwright.Locator.html#get_by_text/3-arguments"},{"type":"function","title":"Playwright.Locator.hover/2","doc":"Hovers over the element.\n\nPerforms the following steps:\n\n1. Wait for actionability checks on the matched element, unless\n  `option: force` option is set. If the element is detached during the checks,\n  the whole action is retried.\n2. Scroll the element into view if needed.\n3. Use `Page.Mouse` to hover over the center of the element, or the specified\n  `option: position`.\n4. Wait for initiated navigations to either succeed or fail, unless\n  `option: no_wait_after` is set.\n\nWhen all steps combined have not finished during the specified `option: timeout`,\nthrows a `TimeoutError`. Passing `0` timeout disables this.","ref":"Playwright.Locator.html#hover/2"},{"type":"function","title":"Returns - Playwright.Locator.hover/2","doc":"- `:ok`","ref":"Playwright.Locator.html#hover/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.hover/2","doc":"| key/name         | type   |                                   | description |\n| ---------------- | ------ | --------------------------------- | ----------- |\n| `selector`       | param  | `binary()`                        | A selector to search for an element. If there are multiple elements satisfying the selector, the first will be used. See \"working with selectors (guide)\" for more details. |\n| `:force`         | option | `boolean()`                       | Whether to bypass the actionability checks. `(default: false)` |\n| `:modifiers`     | option | `[:alt, :control, :meta, :shift]` | Modifier keys to press. Ensures that only these modifiers are pressed during the operation, and then restores current modifiers back. If not specified, currently pressed modifiers are used. |\n| `:no_wait_after` | option | `boolean()`                       | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}`                   | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:timeout`       | option | `number()`                        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`                       | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Locator.html#hover/2-arguments"},{"type":"function","title":"Playwright.Locator.inner_html/2","doc":"Returns the `element.innerHTML`.","ref":"Playwright.Locator.html#inner_html/2"},{"type":"function","title":"Arguments - Playwright.Locator.inner_html/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#inner_html/2-arguments"},{"type":"function","title":"Playwright.Locator.inner_text/2","doc":"Returns the `element.innerText`.","ref":"Playwright.Locator.html#inner_text/2"},{"type":"function","title":"Arguments - Playwright.Locator.inner_text/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#inner_text/2-arguments"},{"type":"function","title":"Playwright.Locator.input_value/2","doc":"Returns the `input.value`.\n\nWorks on ` `, ` `, or ` ` elements. Throws for\nnon-input elements.","ref":"Playwright.Locator.html#input_value/2"},{"type":"function","title":"Arguments - Playwright.Locator.input_value/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#input_value/2-arguments"},{"type":"function","title":"Playwright.Locator.is_checked/2","doc":"Returns whether the element is checked.\n\nThrows if the element is not a checkbox or radio input.","ref":"Playwright.Locator.html#is_checked/2"},{"type":"function","title":"Arguments - Playwright.Locator.is_checked/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#is_checked/2-arguments"},{"type":"function","title":"Playwright.Locator.is_disabled/2","doc":"Returns whether the element is disabled.","ref":"Playwright.Locator.html#is_disabled/2"},{"type":"function","title":"Arguments - Playwright.Locator.is_disabled/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#is_disabled/2-arguments"},{"type":"function","title":"Playwright.Locator.is_editable/2","doc":"Returns whether the element is editable.","ref":"Playwright.Locator.html#is_editable/2"},{"type":"function","title":"Arguments - Playwright.Locator.is_editable/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#is_editable/2-arguments"},{"type":"function","title":"Playwright.Locator.is_enabled/2","doc":"Returns whether the element is enabled.","ref":"Playwright.Locator.html#is_enabled/2"},{"type":"function","title":"Arguments - Playwright.Locator.is_enabled/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#is_enabled/2-arguments"},{"type":"function","title":"Playwright.Locator.is_hidden/2","doc":"Returns whether the element is hidden.","ref":"Playwright.Locator.html#is_hidden/2"},{"type":"function","title":"Arguments - Playwright.Locator.is_hidden/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#is_hidden/2-arguments"},{"type":"function","title":"Playwright.Locator.is_visible/2","doc":"Returns whether the element is visible.","ref":"Playwright.Locator.html#is_visible/2"},{"type":"function","title":"Arguments - Playwright.Locator.is_visible/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#is_visible/2-arguments"},{"type":"function","title":"Playwright.Locator.last/1","doc":"Returns a new `Playwright.Locator` scoped to the last matching element.","ref":"Playwright.Locator.html#last/1"},{"type":"function","title":"Playwright.Locator.locator/2","doc":"Returns a new `Playwright.Locator` scoped to the Locator's subtree.","ref":"Playwright.Locator.html#locator/2"},{"type":"function","title":"Playwright.Locator.new/2","doc":"Creates a `Playwright.Locator`.","ref":"Playwright.Locator.html#new/2"},{"type":"function","title":"Returns - Playwright.Locator.new/2","doc":"- `Playwright.Locator`","ref":"Playwright.Locator.html#new/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.new/2","doc":"| key/name          | type   |                        | description |\n| ----------------- | ------ | ---------------------- | ----------- |\n| `frame` or `page` | param  | `Frame.t() | Page.t()` |  |\n| `selector`        | param  | `binary()`             | A Playwright selector. |","ref":"Playwright.Locator.html#new/2-arguments"},{"type":"function","title":"Playwright.Locator.nth/2","doc":"Returns a new `Playwright.Locator` scoped to the n-th matching element.","ref":"Playwright.Locator.html#nth/2"},{"type":"function","title":"Playwright.Locator.press/3","doc":"Focuses the element, and then uses `keyboard.down(key)` and `keyboard.up(key)`.\n\n`param: key` can specify the intended [keyboardEvent.key](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key)\nvalue or a single character. A superset of the key values can be found [on MDN](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values).\n\nExamples of the keys are:\n\n- `F1` - `F12`\n- `Digit0` - `Digit9`\n- `KeyA` - `KeyZ`\n- `Backquote`\n- `Minus`\n- `Equal`\n- `Backslash`\n- `Backspace`\n- `Tab`\n- `Delete`\n- `Escape`\n- `ArrowDown`\n- `End`\n- `Enter`\n- `Home`\n- `Insert`\n- `PageDown`\n- `PageUp`\n- `ArrowRight`\n- `ArrowUp`\n\nThe fllowing modification shortcuts are also supported:\n\n- `Shift`\n- `Control`\n- `Alt`\n- `Meta`\n- `ShiftLeft`\n\nHolding down `Shift` will type the text that corresponds to the `param: key`\nin the upper case.\n\nIf `param: key` is a single character, it is case-sensitive, so the values\n`a` and `A` will generate different respective texts.\n\nShortcuts such as `key: \"Control+o\"` or `key: \"Control+Shift+T\"` are\nsupported as well. When specified with the modifier, modifier is pressed\nand held while the subsequent key is pressed.","ref":"Playwright.Locator.html#press/3"},{"type":"function","title":"Arguments - Playwright.Locator.press/3","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `key`            | param  | `binary()`      | Name of the key to press or a character to generate, such as `ArrowLeft` or `a`. |\n| `:delay`         | option | `number()`      | Time to wait between `mousedown` and `mouseup` in milliseconds. `(default: 0)` |\n| `:no_wait_after` | option | `boolean()`     | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#press/3-arguments"},{"type":"function","title":"Playwright.Locator.screenshot/2","doc":"Returns a buffer with the captured screenshot data.\n\nWaits for the actionability checks, then scrolls element into view before\ntaking a screenshot. If the element is detached from DOM, throws an error.","ref":"Playwright.Locator.html#screenshot/2"},{"type":"function","title":"Arguments - Playwright.Locator.screenshot/2","doc":"| key/name           | type   |                   | description |\n| ------------------ | ------ | ----------------- | ----------- |\n| `:omit_background` | option | `boolean()`       | Hides default white background and allows capturing screenshots with transparency. Not applicable to jpeg images. `(default: false)` |\n| `:path`            | option | `binary()`        | The file path to which to save the image. The screenshot type will be inferred from file extension. If path is a relative path, then it is resolved relative to the current working directory. If no path is provided, the image won't be saved to the disk. |\n| `:quality`         | option | `number()`        | The quality of the image, between 0-100. Not applicable to `png` images. |\n| `:timeout`         | option | `number()`        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |\n| `:type`            | option | `:png` or `:jpeg` | Specify screenshot type. `(default: :png)` |","ref":"Playwright.Locator.html#screenshot/2-arguments"},{"type":"function","title":"Playwright.Locator.scroll_into_view/2","doc":"Waits for actionability checks, then tries to scroll element into view,\nunless it is completely visible as defined by [IntersectionObserver](https://developer.mozilla.org/en-US/docs/Web/API/Intersection_Observer_API)'s\nratio.","ref":"Playwright.Locator.html#scroll_into_view/2"},{"type":"function","title":"Arguments - Playwright.Locator.scroll_into_view/2","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#scroll_into_view/2-arguments"},{"type":"function","title":"Playwright.Locator.select_option/3","doc":"Selects one or more options from a ` ` element.\n\nPerforms the following steps:\n\n1. Waits for actionability checks\n2. Waits until all specified options are present in the ` ` element\n3. Selects those options\n\nIf the target element is not a ` ` element, raises an error. However,\nif the element is inside the ` ` element that has an associated control,\nthe control will be used instead.\n\nReturns the list of option values that have been successfully selected.\n\nTriggers a change and input event once all the provided options have been selected.","ref":"Playwright.Locator.html#select_option/3"},{"type":"function","title":"Example - Playwright.Locator.select_option/3","doc":"alias Playwright.Locator\n    locator = Locator.new(page, \"select#colors\")\n\n    # single selection matching the value\n    Locator.select_option(locator, \"blue\")\n\n    # single selection matching both the label\n    Locator.select_option(locator, %{label: \"blue\"})\n\n    # multiple selection\n    Locator.select_option(locator, %{value: [\"red\", \"green\", \"blue\"]})","ref":"Playwright.Locator.html#select_option/3-example"},{"type":"function","title":"Returns - Playwright.Locator.select_option/3","doc":"- `[binary()]`","ref":"Playwright.Locator.html#select_option/3-returns"},{"type":"function","title":"Arguments - Playwright.Locator.select_option/3","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `values`         | param  | `any()`         | Options to select. |\n| `:force`         | option | `boolean()`     | Whether to bypass the actionability checks. `(default: false)` |\n| `:no_wait_after` | option | `boolean()`     | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#select_option/3-arguments"},{"type":"function","title":"On `values` - Playwright.Locator.select_option/3","doc":"If the ` ` has the `multiple` attribute, all matching options are\nselected, otherwise only the first option matching one of the passed options\nis selected.\n\nString values are equivalent to `%{value: \"string\"}`.\n\nOption is considered matching if all specified properties match.\n\n- `value  ` Matches by `option.value`. `(optional)`.\n- `label  ` Matches by `option.label`. `(optional)`.\n- `index  ` Matches by the index. `(optional)`.","ref":"Playwright.Locator.html#select_option/3-on-values"},{"type":"function","title":"Playwright.Locator.select_text/2","doc":"Waits for actionability checks, then focuses the element and selects all its\ntext content.","ref":"Playwright.Locator.html#select_text/2"},{"type":"function","title":"Arguments - Playwright.Locator.select_text/2","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `:force`         | option | `boolean()`     | Whether to bypass the actionability checks. `(default: false)` |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#select_text/2-arguments"},{"type":"function","title":"Playwright.Locator.set_checked/3","doc":"Checks or unchecks an element.\n\nPerforms the following steps and checks:\n\n  1. Ensure that the matched element is a checkbox or a radio input. If not,\n    the call throws.\n  2. If the element already has the right checked state, returns immediately.\n  3. Wait for actionability checks on the matched element, unless\n    `option: force` is set. If the element is detached during the checks, the\n    whole action is retried.\n  4. Scroll the element into view if needed.\n  5. Use `Page.Mouse` to click in the center of the element.\n  6. Wait for initiated navigations to either succeed or fail, unless\n    `option: no_wait_after` is set.\n  7. Ensure that the element is now checked or unchecked.\n    If not, the call throws.\n\nWhen all steps combined have not finished during the specified timeout,\nthrows a `TimeoutError`. Passing `0` timeout disables this.","ref":"Playwright.Locator.html#set_checked/3"},{"type":"function","title":"Arguments - Playwright.Locator.set_checked/3","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `checked`        | param  | `boolean()`     | Whether to check or uncheck the checkbox. |\n| `:force`         | option | `boolean()`     | Whether to bypass the actionability checks. `(default: false)` |\n| `:no_wait_after` | option | `boolean()`     | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}` | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`     | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Locator.html#set_checked/3-arguments"},{"type":"function","title":"Playwright.Locator.set_input_files/3","doc":"Sets the value of the file input to these file paths or files.\n\nIf some of the file paths are relative paths, they are resolved relative to\nthe the current working directory. An empty list, clears the selected files.\n\nExpects element (i.e., `locator.selector`) to point to an input element.\n\n# **NOTE:**\n# Of `payloads`, `local_paths`, and `streams` playwright-core capabilities,\n# only `local_paths` is currently supported by playwright-elixir.","ref":"Playwright.Locator.html#set_input_files/3"},{"type":"function","title":"Arguments - Playwright.Locator.set_input_files/3","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `files`          | param  | `any()`         | ... |\n| `:no_wait_after` | option | `boolean()`     | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#set_input_files/3-arguments"},{"type":"function","title":"Playwright.Locator.string/1","doc":"Returns a string representation of the `Playwright.Locator`.","ref":"Playwright.Locator.html#string/1"},{"type":"function","title":"Playwright.Locator.tap/2","doc":"Taps the element (i.e., mimicking trackpad input).\n\nPerforms the following steps:\n\n  1. Wait for actionability checks on the element, unless `option: force`\n    is set.\n  2. Scroll the element into view if needed.\n  3. Use `Page.Touchscreen` to tap the center of the element, or the\n    specified position.\n  4. Wait for initiated navigations to either succeed or fail, unless\n    `option: no_wait_after` is set.\n\nIf the element is detached from the DOM at any moment during the action,\nthrows an error.\n\nWhen all steps combined have not finished during the specified timeout,\nthrows a `TimeoutError`. Passing `0` timeout disables this.\n\n> NOTE:\n>\n> `tap/2` requires that the `:has_touch` option of the browser context be\n> set to `true`.","ref":"Playwright.Locator.html#tap/2"},{"type":"function","title":"Arguments - Playwright.Locator.tap/2","doc":"| key/name         | type   |                                   | description |\n| ---------------- | ------ | --------------------------------- | ----------- |\n| `:force`         | option | `boolean()`                       | Whether to bypass the actionability checks. `(default: false)` |\n| `:modifiers`     | option | `[:alt, :control, :meta, :shift]` | Modifier keys to press. Ensures that only these modifiers are pressed during the operation, and then restores current modifiers back. If not specified, currently pressed modifiers are used. |\n| `:no_wait_after` | option | `boolean()`                       | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}`                   | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:timeout`       | option | `number()`                        | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`                       | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Locator.html#tap/2-arguments"},{"type":"function","title":"Playwright.Locator.text_content/2","doc":"Returns the `node.textContent`.","ref":"Playwright.Locator.html#text_content/2"},{"type":"function","title":"Arguments - Playwright.Locator.text_content/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `:timeout` | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed by using the `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2` functions. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#text_content/2-arguments"},{"type":"function","title":"Playwright.Locator.type/3","doc":"Focuses the element, and then sends a `keydown`, `keypress/input`, and\n`keyup` event for each character in the text.\n\nTo press a special key, like `Control` or `ArrowDown`, use\n`Playwright.Locator.press/3`.","ref":"Playwright.Locator.html#type/3"},{"type":"function","title":"Arguments - Playwright.Locator.type/3","doc":"| key/name         | type   |             | description |\n| ---------------- | ------ | ----------- | ----------- |\n| `text`           | param  | `binary()`  | Text to type into a focused element. |\n| `:delay`         | option | `number()`  | Time to wait between `mousedown` and `mouseup` in milliseconds. `(default: 0)` |\n| `:no_wait_after` | option | `boolean()` | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:timeout`       | option | `number()`  | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |","ref":"Playwright.Locator.html#type/3-arguments"},{"type":"function","title":"Playwright.Locator.uncheck/2","doc":"Unchecks the (checkmark) element by performing the following steps:\n\n  1. Ensure that element is a checkbox or a radio input. If not, this method\n    throws. If the element is already checked, this method returns immediately.\n  2. Wait for actionability checks on the element, unless force option is set.\n  3. Scroll the element into view if needed.\n  4. Use `Playwright.Page.Mouse` to click in the center of the element.\n  5. Wait for initiated navigations to either succeed or fail, unless\n    `option: no_wait_after` is set.\n  6. Ensure that the element is now checked. If not, this method throws.\n\nIf the element is detached from the DOM at any moment during the action,\nthis method throws.\n\nWhen all steps combined have not finished during the specified timeout, this\nmethod throws a `TimeoutError`. Passing `0` timeout disables this.","ref":"Playwright.Locator.html#uncheck/2"},{"type":"function","title":"Returns - Playwright.Locator.uncheck/2","doc":"- `:ok`","ref":"Playwright.Locator.html#uncheck/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.uncheck/2","doc":"| key/name         | type   |                 | description |\n| ---------------- | ------ | --------------- | ----------- |\n| `:force`         | option | `boolean()`     | Whether to bypass the actionability checks. `(default: false)` |\n| `:no_wait_after` | option | `boolean()`     | Actions that initiate navigations are waiting for these navigations to happen and for pages to start loading. You can opt out of waiting via setting this flag. You would only need this option in the exceptional cases such as navigating to inaccessible pages. `(default: false)` |\n| `:position`      | option | `%{x: x, y: y}` | A point to use relative to the top-left corner of element padding box. If not specified, uses some visible point of the element. |\n| `:timeout`       | option | `number()`      | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |\n| `:trial`         | option | `boolean()`     | When set, this call only performs the actionability checks and skips the action. Useful to wait until the element is ready for the action without performing it. `(default: false)` |","ref":"Playwright.Locator.html#uncheck/2-arguments"},{"type":"function","title":"Playwright.Locator.wait_for/2","doc":"Returns when element specified by locator satisfies `option: state`.\n\nIf target element already satisfies the condition, the method returns\nimmediately. Otherwise, waits for up to `option: timeout` milliseconds until\nthe condition is met.","ref":"Playwright.Locator.html#wait_for/2"},{"type":"function","title":"Returns - Playwright.Locator.wait_for/2","doc":"- `Locator.t()`","ref":"Playwright.Locator.html#wait_for/2-returns"},{"type":"function","title":"Arguments - Playwright.Locator.wait_for/2","doc":"| key/name   | type   |              | description |\n| ---------- | ------ | ------------ | ----------- |\n| `:state`   | option | state option | Defaults to `visible`. See \"Options for `:state`\" below\". |\n| `:timeout` | option | float        | Maximum time in milliseconds, defaults to 30 seconds, pass 0 to disable timeout. The default value can be changed by using the browser_context.set_default_timeout(timeout) or page.set_default_timeout(timeout) methods. |","ref":"Playwright.Locator.html#wait_for/2-arguments"},{"type":"function","title":"Options for `:state` - Playwright.Locator.wait_for/2","doc":"| value      | description |\n| ---------- | ----------- |\n| 'attached' | wait for element to be present in DOM. (default) |\n| 'detached' | wait for element to not be present in DOM. |\n| 'visible'  | wait for element to have non-empty bounding box and no visibility:hidden. Note that element without any content or with display:none has an empty bounding box and is not considered visible. |\n| 'hidden'   | wait for element to be either detached from DOM, or have an empty bounding box or visibility:hidden. This is opposite to the 'visible' option. |","ref":"Playwright.Locator.html#wait_for/2-options-for-state"},{"type":"function","title":"Example - Playwright.Locator.wait_for/2","doc":"...","ref":"Playwright.Locator.html#wait_for/2-example"},{"type":"type","title":"Playwright.Locator.options/0","doc":"","ref":"Playwright.Locator.html#t:options/0"},{"type":"type","title":"Playwright.Locator.options_click/0","doc":"","ref":"Playwright.Locator.html#t:options_click/0"},{"type":"type","title":"Playwright.Locator.options_keyboard/0","doc":"","ref":"Playwright.Locator.html#t:options_keyboard/0"},{"type":"type","title":"Playwright.Locator.options_position/0","doc":"","ref":"Playwright.Locator.html#t:options_position/0"},{"type":"type","title":"Playwright.Locator.param_input_button/0","doc":"","ref":"Playwright.Locator.html#t:param_input_button/0"},{"type":"type","title":"Playwright.Locator.selector/0","doc":"","ref":"Playwright.Locator.html#t:selector/0"},{"type":"type","title":"Playwright.Locator.serializable/0","doc":"","ref":"Playwright.Locator.html#t:serializable/0"},{"type":"type","title":"Playwright.Locator.t/0","doc":"","ref":"Playwright.Locator.html#t:t/0"},{"type":"module","title":"Playwright.Page","doc":"`Page` provides methods to interact with a single tab in a\n`Playwright.Browser`, or an [extension background page](https://developer.chrome.com/extensions/background_pages)\nin Chromium.\n\nOne `Playwright.Browser` instance might have multiple `Page` instances.","ref":"Playwright.Page.html"},{"type":"module","title":"Example - Playwright.Page","doc":"Create a page, navigate it to a URL, and save a screenshot:\n\n    page = Browser.new_page(browser)\n    resp = Page.goto(page, \"https://example.com\")\n\n    Page.screenshot(page, %{path: \"screenshot.png\"})\n    :ok = Page.close(page)\n\nThe Page module is capable of handling various emitted events (described below).","ref":"Playwright.Page.html#module-example"},{"type":"module","title":"Example - Playwright.Page","doc":"Log a message for a single page load event (WIP: `once` is not yet implemented):\n\n    Page.once(page, :load, fn e ->\n      IO.puts(\"page loaded!\")\n    end)\n\nUnsubscribe from events with the `remove_lstener` function (WIP: `remove_listener` is not yet implemented):\n\n    def log_request(request) do\n      IO.inspect(label: \"A request was made\")\n    end\n\n    Page.on(page, :request, fn e ->\n      log_request(e.pages.request)\n    end)\n\n    Page.remove_listener(page, log_request)","ref":"Playwright.Page.html#module-example"},{"type":"function","title":"Playwright.Page.add_init_script/2","doc":"Adds a script to be evaluated before other scripts.\n\nThe script is evaluated in the following scenarios:\n\n- Whenever the page is navigated.\n- Whenever a child frame is attached or navigated. In this case, the script\n  is evaluated in the context of the newly attached frame.\n\nThe script is evaluated after the document is created but before any of its\nscripts are run. This is useful to amend the JavaScript environment, e.g. to\nseed `Math.random`.","ref":"Playwright.Page.html#add_init_script/2"},{"type":"function","title":"Returns - Playwright.Page.add_init_script/2","doc":"- `:ok`","ref":"Playwright.Page.html#add_init_script/2-returns"},{"type":"function","title":"Arguments - Playwright.Page.add_init_script/2","doc":"| key/name    | type   |                       | description |\n| ----------- | ------ | --------------------- | ----------- |\n| `script`    | param  | `binary()` or `map()` | As `binary()`: an inlined script to be evaluated; As `%{path: path}`: a path to a JavaScript file. |","ref":"Playwright.Page.html#add_init_script/2-arguments"},{"type":"function","title":"Example - Playwright.Page.add_init_script/2","doc":"Overriding `Math.random` before the page loads:\n\n    # preload.js\n    Math.random = () => 42;\n\n    Page.add_init_script(page, %{path: \"preload.js\"})","ref":"Playwright.Page.html#add_init_script/2-example"},{"type":"function","title":"Notes - Playwright.Page.add_init_script/2","doc":"> While the official Node.js Playwright implementation supports an optional\n> `param: arg` for this function, the official Python implementation does\n> not. This implementation matches the Python for now.\n\n> The order of evaluation of multiple scripts installed via\n> `Playwright.BrowserContext.add_init_script/2` and\n> `Playwright.Page.add_init_script/2` is not defined.","ref":"Playwright.Page.html#add_init_script/2-notes"},{"type":"function","title":"Playwright.Page.click/3","doc":"","ref":"Playwright.Page.html#click/3"},{"type":"function","title":"Playwright.Page.close/2","doc":"Closes the `Page`.\n\nIf the `Page` has an \"owned context\" (1-to-1 co-dependency with a\n`Playwright.BrowserContext`), that context is closed as well.\n\nIf `option: run_before_unload` is false, does not run any unload handlers and\nwaits for the page to be closed. If `option: run_before_unload` is `true`\nthe function will run unload handlers, but will not wait for the page to\nclose. By default, `Playwright.Page.close/1` does not run `:beforeunload`\nhandlers.","ref":"Playwright.Page.html#close/2"},{"type":"function","title":"Returns - Playwright.Page.close/2","doc":"- `:ok`","ref":"Playwright.Page.html#close/2-returns"},{"type":"function","title":"Arguments - Playwright.Page.close/2","doc":"| key/name            | type   |             | description |\n| ------------------- | ------ | ----------- | ----------- |\n| `run_before_unload` | option | `boolean()` | Whether to run the before unload page handlers. `(default: false)` |","ref":"Playwright.Page.html#close/2-arguments"},{"type":"function","title":"NOTE - Playwright.Page.close/2","doc":"> if `option: run_before_unload` is passed as `true`, a `:beforeunload`\n> dialog might be summoned and should be handled manually via\n> `Playwright.Page.on/3`.","ref":"Playwright.Page.html#close/2-note"},{"type":"function","title":"Playwright.Page.context/1","doc":"Get the `Playwright.BrowserContext` that the page belongs to.","ref":"Playwright.Page.html#context/1"},{"type":"function","title":"Playwright.Page.dblclick/3","doc":"A shortcut for the main frame's `Playwright.Frame.dblclick/3`.","ref":"Playwright.Page.html#dblclick/3"},{"type":"function","title":"Playwright.Page.dispatch_event/5","doc":"A shortcut for the main frame's `Playwright.Frame.dispatch_event/5`.","ref":"Playwright.Page.html#dispatch_event/5"},{"type":"function","title":"Playwright.Page.drag_and_drop/4","doc":"","ref":"Playwright.Page.html#drag_and_drop/4"},{"type":"function","title":"Playwright.Page.eval_on_selector/5","doc":"","ref":"Playwright.Page.html#eval_on_selector/5"},{"type":"function","title":"Playwright.Page.evaluate/3","doc":"","ref":"Playwright.Page.html#evaluate/3"},{"type":"function","title":"Playwright.Page.evaluate_handle/3","doc":"","ref":"Playwright.Page.html#evaluate_handle/3"},{"type":"function","title":"Playwright.Page.expect_event/4","doc":"","ref":"Playwright.Page.html#expect_event/4"},{"type":"function","title":"Playwright.Page.expose_binding/4","doc":"Adds a function called `param:name` on the `window` object of every frame in\nthis page.\n\nWhen called, the function executes `param:callback` and resolves to the return\nvalue of the `callback`.\n\nThe first argument to the `callback` function includes the following details\nabout the caller:\n\n    %{\n      context: %Playwright.BrowserContext{},\n      frame:   %Playwright.Frame{},\n      page:    %Playwright.Page{}\n    }\n\nSee `Playwright.BrowserContext.expose_binding/4` for a similar,\ncontext-scoped version.","ref":"Playwright.Page.html#expose_binding/4"},{"type":"function","title":"Playwright.Page.expose_function/3","doc":"Adds a function called `param:name` on the `window` object of every frame in\nthe page.\n\nWhen called, the function executes `param:callback` and resolves to the return\nvalue of the `callback`.\n\nSee `Playwright.BrowserContext.expose_function/3` for a similar,\ncontext-scoped version.","ref":"Playwright.Page.html#expose_function/3"},{"type":"function","title":"Playwright.Page.fill/4","doc":"","ref":"Playwright.Page.html#fill/4"},{"type":"function","title":"Playwright.Page.focus/3","doc":"A shortcut for the main frame's `Playwright.Frame.focus/3`.","ref":"Playwright.Page.html#focus/3"},{"type":"function","title":"Playwright.Page.frames/1","doc":"","ref":"Playwright.Page.html#frames/1"},{"type":"function","title":"Playwright.Page.get_attribute/4","doc":"","ref":"Playwright.Page.html#get_attribute/4"},{"type":"function","title":"Playwright.Page.get_by_text/3","doc":"Allows locating elements that contain given text.","ref":"Playwright.Page.html#get_by_text/3"},{"type":"function","title":"Arguments - Playwright.Page.get_by_text/3","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `text`     | param  | `binary()` | Text to locate the element for. |\n| `:exact`   | option | `boolean()`| Whether to find an exact match: case-sensitive and whole-string. Default to false. Ignored when locating by a regular expression. Note that exact match still trims whitespace. |","ref":"Playwright.Page.html#get_by_text/3-arguments"},{"type":"function","title":"Playwright.Page.goto/3","doc":"","ref":"Playwright.Page.html#goto/3"},{"type":"function","title":"Playwright.Page.hover/2","doc":"A shortcut for the main frame's `Playwright.Frame.hover/2`.","ref":"Playwright.Page.html#hover/2"},{"type":"function","title":"Playwright.Page.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Page.html#init/2"},{"type":"function","title":"Example - Playwright.Page.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Page.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Page.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Page.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Page.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Page.html#init/2-arguments"},{"type":"function","title":"Playwright.Page.locator/2","doc":"","ref":"Playwright.Page.html#locator/2"},{"type":"function","title":"Playwright.Page.on/3","doc":"","ref":"Playwright.Page.html#on/3"},{"type":"function","title":"Playwright.Page.press/4","doc":"","ref":"Playwright.Page.html#press/4"},{"type":"function","title":"Playwright.Page.q/3","doc":"","ref":"Playwright.Page.html#q/3"},{"type":"function","title":"Playwright.Page.qq/3","doc":"","ref":"Playwright.Page.html#qq/3"},{"type":"function","title":"Playwright.Page.query_selector/3","doc":"","ref":"Playwright.Page.html#query_selector/3"},{"type":"function","title":"Playwright.Page.query_selector_all/3","doc":"","ref":"Playwright.Page.html#query_selector_all/3"},{"type":"function","title":"Playwright.Page.reload/2","doc":"Reloads the current page.\n\nReloads in the same way as if the user had triggered a browser refresh.\n\nReturns the main resource response. In case of multiple redirects, the\nnavigation will resolve with the response of the last redirect.","ref":"Playwright.Page.html#reload/2"},{"type":"function","title":"Returns - Playwright.Page.reload/2","doc":"- `Playwright.Response.t() | nil`","ref":"Playwright.Page.html#reload/2-returns"},{"type":"function","title":"Arguments - Playwright.Page.reload/2","doc":"| key/name      | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `:timeout`    | option | `number()` | Maximum time in milliseconds. Pass `0` to disable timeout. The default value can be changed via `Playwright.BrowserContext.set_default_timeout/2` or `Playwright.Page.set_default_timeout/2`. `(default: 30 seconds)` |\n| `:wait_until` | option | `binary()` | \"load\", \"domcontentloaded\", \"networkidle\", or \"commit\". When to consider the operation as having succeeded. `(default: \"load\")` |","ref":"Playwright.Page.html#reload/2-arguments"},{"type":"function","title":"On Wait Events - Playwright.Page.reload/2","doc":"- `domcontentloaded` - consider operation to be finished when the `DOMContentLoaded` event is fired.\n- `load` - consider operation to be finished when the `load` event is fired.\n- `networkidle` - consider operation to be finished when there are no network connections for at least `500 ms`.\n- `commit` - consider operation to be finished when network response is received and the document started loading.","ref":"Playwright.Page.html#reload/2-on-wait-events"},{"type":"function","title":"Playwright.Page.request/1","doc":"","ref":"Playwright.Page.html#request/1"},{"type":"function","title":"Playwright.Page.route/4","doc":"","ref":"Playwright.Page.html#route/4"},{"type":"function","title":"Playwright.Page.screenshot/2","doc":"","ref":"Playwright.Page.html#screenshot/2"},{"type":"function","title":"Playwright.Page.select_option/4","doc":"A shortcut for the main frame's `Playwright.Frame.select_option/4`.","ref":"Playwright.Page.html#select_option/4"},{"type":"function","title":"Playwright.Page.set_content/3","doc":"","ref":"Playwright.Page.html#set_content/3"},{"type":"function","title":"Playwright.Page.set_viewport_size/2","doc":"","ref":"Playwright.Page.html#set_viewport_size/2"},{"type":"function","title":"Playwright.Page.text_content/3","doc":"","ref":"Playwright.Page.html#text_content/3"},{"type":"function","title":"Playwright.Page.title/1","doc":"","ref":"Playwright.Page.html#title/1"},{"type":"function","title":"Playwright.Page.url/1","doc":"","ref":"Playwright.Page.html#url/1"},{"type":"function","title":"Playwright.Page.wait_for_load_state/3","doc":"","ref":"Playwright.Page.html#wait_for_load_state/3"},{"type":"function","title":"Playwright.Page.wait_for_selector/3","doc":"","ref":"Playwright.Page.html#wait_for_selector/3"},{"type":"type","title":"Playwright.Page.dimensions/0","doc":"","ref":"Playwright.Page.html#t:dimensions/0"},{"type":"type","title":"Playwright.Page.expression/0","doc":"","ref":"Playwright.Page.html#t:expression/0"},{"type":"type","title":"Playwright.Page.function_or_options/0","doc":"","ref":"Playwright.Page.html#t:function_or_options/0"},{"type":"type","title":"Playwright.Page.options/0","doc":"","ref":"Playwright.Page.html#t:options/0"},{"type":"type","title":"Playwright.Page.selector/0","doc":"","ref":"Playwright.Page.html#t:selector/0"},{"type":"type","title":"Playwright.Page.serializable/0","doc":"","ref":"Playwright.Page.html#t:serializable/0"},{"type":"type","title":"Playwright.Page.t/0","doc":"%Playwright.Page{}","ref":"Playwright.Page.html#t:t/0"},{"type":"module","title":"Playwright.Page.Accessibility","doc":"`Playwright.Page.Accessibility` provides functions for inspecting Chromium's accessibility tree.\n\nThe accessibility tree is used by assistive technology such as [screen readers][1] or [switches][2].\n\nAccessibility is a very platform-specific thing. On different platforms, there are different screen readers that\nmight have wildly different output.\n\nRendering engines of Chromium, Firefox and WebKit have a concept of \"accessibility tree\", which is then translated\ninto different platform-specific APIs. Accessibility namespace gives access to this Accessibility Tree.\n\nMost of the accessibility tree gets filtered out when converting from internal browser AX Tree to Platform-specific\nAX-Tree or by assistive technologies themselves. By default, Playwright tries to approximate this filtering,\nexposing only the \"interesting\" nodes of the tree.\n\n[1]: https://en.wikipedia.org/wiki/Screen_reader\n[2]: https://en.wikipedia.org/wiki/Switch_access","ref":"Playwright.Page.Accessibility.html"},{"type":"function","title":"Playwright.Page.Accessibility.snapshot/2","doc":"Captures the current state of the accessibility tree.\n\nThe result represents the root accessible node of the page.","ref":"Playwright.Page.Accessibility.html#snapshot/2"},{"type":"function","title":"Examples - Playwright.Page.Accessibility.snapshot/2","doc":"Dumping an entire accessibility tree:\n\n    Browser.new_page(browser)\n      |> Page.set_content(\" Hello! \")\n      |> Page.Accessibility.snapshot()\n    %{children: [%{name: \"Hello!\", role: \"text\"}], name: \"\", role: \"WebArea\"}\n\nRetrieving the name of a focused node:\n\n    body = \"  \"\n    Browser.new_page(browser)\n      |> Page.set_content(body)\n      |> Page.Accessibility.snapshot()\n      |> (&(Enum.find(&1.children, fn e -> e.readonly end))).()\n    %{name: \"pick me\", readonly: true, role: \"textbox\"}","ref":"Playwright.Page.Accessibility.html#snapshot/2-examples"},{"type":"type","title":"Playwright.Page.Accessibility.options/0","doc":"Options given to `snapshot/2`\n\n- `:interesting_only` - Prune uninteresting nodes from the tree (default: true)\n- `:root` - The root DOM element for the snapshot (default: page)","ref":"Playwright.Page.Accessibility.html#t:options/0"},{"type":"type","title":"Playwright.Page.Accessibility.snapshot/0","doc":"Snapshot result returned from `snapshot/2`\n\n- `:name` - A human readable name for the node\n- `:description` - An additional human readable description of the node, if applicable\n- `:role` - The role\n- `:value` - The current value of the node, if applicable\n- `:children` - Child nodes, if any, if applicable\n- `:autocomplete` - What kind of autocomplete is supported by a control, if applicable\n- `:checked` - Whether the checkbox is checked, or \"mixed\", if applicable\n- `:disabled` - Whether the node is disabled, if applicable\n- `:expanded` - Whether the node is expanded or collapsed, if applicable\n- `:focused` - Whether the node is focused, if applicable\n- `:haspopup` - What kind of popup is currently being shown for a node, if applicable\n- `:invalid` - Whether and in what way this node's value is invalid, if applicable\n- `:keyshortcuts` - Keyboard shortcuts associated with this node, if applicable\n- `:level` - The level of a heading, if applicable\n- `:modal` - Whether the node is modal, if applicable\n- `:multiline` - Whether the node text input supports multiline, if applicable\n- `:multiselectable` - Whether more than one child can be selected, if applicable\n- `:orientation` - Whether the node is oriented horizontally or vertically, if applicable\n- `:pressed` - Whether the toggle button is checked, or \"mixed\", if applicable\n- `:readonly` - Whether the node is read only, if applicable\n- `:required` - Whether the node is required, if applicable\n- `:roledescription` - A human readable alternative to the role, if applicable\n- `:selected` - Whether the node is selected in its parent node, if applicable\n- `:valuemax` - The maximum value in a node, if applicable\n- `:valuemin` - The minimum value in a node, if applicable\n- `:valuetext` - A description of the current value, if applicable","ref":"Playwright.Page.Accessibility.html#t:snapshot/0"},{"type":"module","title":"Playwright.Request","doc":"`Playwright.Request` represents a request for a network resource.\n\nWhenever the page sends a request for a network resource, the following sequence of events are emitted by\n`Playwright.Page`:\n\n- `Playwright.Page.on/3` for \"request\":\n  emitted when the request is issued by the page.\n- `Playwright.Page.on/3` for \"response\":\n  emitted when/if the response status and headers are received for the request.\n- `Playwright.Page.on/3` for \"requestFinished\":\n  emitted when the response body is downloaded and the request is complete.\n\nIf the request fails at some point, instead of a \"requestFinished\" event (and possibly \"response\" as well),\nthe `Playwright.Page.on/3` for \"requestFailed\" is emitted.","ref":"Playwright.Request.html"},{"type":"module","title":"NOTE - Playwright.Request","doc":"> HTTP error responses, such as 404 or 503, are still successful responses from an HTTP stanpoint. So, such requests\n> will complete with a \"requestFinished\" event.\n\nIf a request gets a \"redirect\" response, the request is successfully finished with the \"requestFinished\" event, and a\nnew request is issued to the target redirected URL.","ref":"Playwright.Request.html#module-note"},{"type":"function","title":"Playwright.Request.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Request.html#init/2"},{"type":"function","title":"Example - Playwright.Request.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Request.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Request.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Request.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Request.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Request.html#init/2-arguments"},{"type":"type","title":"Playwright.Request.t/0","doc":"%Playwright.Request{}","ref":"Playwright.Request.html#t:t/0"},{"type":"module","title":"Playwright.Response","doc":"...","ref":"Playwright.Response.html"},{"type":"function","title":"Playwright.Response.body/1","doc":"","ref":"Playwright.Response.html#body/1"},{"type":"function","title":"Playwright.Response.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Response.html#init/2"},{"type":"function","title":"Example - Playwright.Response.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Response.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Response.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Response.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Response.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Response.html#init/2-arguments"},{"type":"function","title":"Playwright.Response.ok/1","doc":"","ref":"Playwright.Response.html#ok/1"},{"type":"function","title":"Playwright.Response.text/1","doc":"","ref":"Playwright.Response.html#text/1"},{"type":"type","title":"Playwright.Response.t/0","doc":"%Playwright.Response{}","ref":"Playwright.Response.html#t:t/0"},{"type":"module","title":"Playwright.Route","doc":"...","ref":"Playwright.Route.html"},{"type":"function","title":"Playwright.Route.continue/2","doc":"","ref":"Playwright.Route.html#continue/2"},{"type":"function","title":"Playwright.Route.fulfill/2","doc":"","ref":"Playwright.Route.html#fulfill/2"},{"type":"function","title":"Playwright.Route.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Route.html#init/2"},{"type":"function","title":"Example - Playwright.Route.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Route.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Route.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Route.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Route.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Route.html#init/2-arguments"},{"type":"type","title":"Playwright.Route.options/0","doc":"","ref":"Playwright.Route.html#t:options/0"},{"type":"type","title":"Playwright.Route.t/0","doc":"%Playwright.Route{}","ref":"Playwright.Route.html#t:t/0"},{"type":"module","title":"Playwright.Selectors","doc":"...","ref":"Playwright.Selectors.html"},{"type":"function","title":"Playwright.Selectors.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Selectors.html#init/2"},{"type":"function","title":"Example - Playwright.Selectors.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Selectors.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Selectors.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Selectors.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Selectors.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Selectors.html#init/2-arguments"},{"type":"type","title":"Playwright.Selectors.options/0","doc":"","ref":"Playwright.Selectors.html#t:options/0"},{"type":"type","title":"Playwright.Selectors.t/0","doc":"%Playwright.Selectors{}","ref":"Playwright.Selectors.html#t:t/0"},{"type":"module","title":"Playwright.WebSocket","doc":"...","ref":"Playwright.WebSocket.html"},{"type":"function","title":"Playwright.WebSocket.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.WebSocket.html#init/2"},{"type":"function","title":"Example - Playwright.WebSocket.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.WebSocket.html#init/2-example"},{"type":"function","title":"Returns - Playwright.WebSocket.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.WebSocket.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.WebSocket.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.WebSocket.html#init/2-arguments"},{"type":"type","title":"Playwright.WebSocket.t/0","doc":"%Playwright.WebSocket{}","ref":"Playwright.WebSocket.html#t:t/0"},{"type":"module","title":"Playwright.Worker","doc":"...","ref":"Playwright.Worker.html"},{"type":"function","title":"Playwright.Worker.init/2","doc":"Optional **callback** implementation for `Playwright.SDK.ChannelOwner.init/2`.\n\nIf implemented, the callback will receive:\n\n  1. The newly created \"channel owner\" struct.\n  2. The `:initializer` received from the Playwright browser server.\n\nThe implementation has the option of \"patching\" the struct as stored in\nthe catalog, and/or binding event handlers.","ref":"Playwright.Worker.html#init/2"},{"type":"function","title":"Example - Playwright.Worker.init/2","doc":"def init(%{session: session} = owner, _initializer) do\n      Channel.bind(session, {:guid, owner.guid}, :close, fn event ->\n        Logger.warning(\"Closing #{inspect(event.target)}\")\n      end)\n\n      {:ok, %{owner | version: \"1.2.3\"}}\n    end","ref":"Playwright.Worker.html#init/2-example"},{"type":"function","title":"Returns - Playwright.Worker.init/2","doc":"- `{:ok, struct()}`","ref":"Playwright.Worker.html#init/2-returns"},{"type":"function","title":"Arguments - Playwright.Worker.init/2","doc":"| key/name    | type   |            | description |\n| ------------- | ------ | ---------- | ----------- |\n| `owner`       | param  | `struct()` | The newly created channel owner (resource). |\n| `initializer` | param  | `struct()` | The initializer received from with the channel owner instance was derived. |","ref":"Playwright.Worker.html#init/2-arguments"},{"type":"type","title":"Playwright.Worker.t/0","doc":"%Playwright.Worker{}","ref":"Playwright.Worker.html#t:t/0"},{"type":"module","title":"Playwright.SDK.CLI","doc":"A wrapper to the Playwright Javascript CLI","ref":"Playwright.SDK.CLI.html"},{"type":"function","title":"Playwright.SDK.CLI.install/0","doc":"","ref":"Playwright.SDK.CLI.html#install/0"},{"type":"module","title":"Playwright.SDK.Channel.Catalog","doc":"Provides storage and management of ChannelOwner instances.\n\n`Catalog` implements `GenServer` to maintain state, while domain logic is\nexpected to be handled within caller modules such as `Playwright.SDK.Channel`.","ref":"Playwright.SDK.Channel.Catalog.html"},{"type":"function","title":"Playwright.SDK.Channel.Catalog.all/1","doc":"","ref":"Playwright.SDK.Channel.Catalog.html#all/1"},{"type":"function","title":"Playwright.SDK.Channel.Catalog.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Playwright.SDK.Channel.Catalog.html#child_spec/1"},{"type":"function","title":"Playwright.SDK.Channel.Catalog.get/3","doc":"Retrieves a resource from the `Catalog` by its `param: guid`.\n\nIf the resource is already present in the `Catalog` that resource is returned\ndirectly. The desired resource might not yet be in the `Catalog`, in which\ncase the request will be considered as \"awaiting\". An awaiting request will\nlater receive a response, when the `Catalog` entry is made, or will time out.","ref":"Playwright.SDK.Channel.Catalog.html#get/3"},{"type":"function","title":"Returns - Playwright.SDK.Channel.Catalog.get/3","doc":"- `resource`\n- `{:error, error}`","ref":"Playwright.SDK.Channel.Catalog.html#get/3-returns"},{"type":"function","title":"Arguments - Playwright.SDK.Channel.Catalog.get/3","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `catalog`  | param  | `pid()`    | PID for the Catalog server |\n| `guid`     | param  | `binary()` | GUID to look up |\n| `:timeout` | option | `float()`  | Maximum time to wait, in milliseconds. Defaults to `30_000` (30 seconds). |","ref":"Playwright.SDK.Channel.Catalog.html#get/3-arguments"},{"type":"function","title":"Playwright.SDK.Channel.Catalog.list/2","doc":"Returns a `List` of resources matching the provided \"filter\".","ref":"Playwright.SDK.Channel.Catalog.html#list/2"},{"type":"function","title":"Returns - Playwright.SDK.Channel.Catalog.list/2","doc":"- [`resource`]\n- []","ref":"Playwright.SDK.Channel.Catalog.html#list/2-returns"},{"type":"function","title":"Arguments - Playwright.SDK.Channel.Catalog.list/2","doc":"| key/name  | type   |         | description |\n| --------- | ------ | ------- | ----------- |\n| `catalog` | param  | `pid()` | PID for the Catalog server |\n| `filter`  | param  | `map()` | Attributes for filtering |","ref":"Playwright.SDK.Channel.Catalog.html#list/2-arguments"},{"type":"function","title":"Playwright.SDK.Channel.Catalog.put/2","doc":"Adds a resource to the `Catalog`, keyed on `:guid`.","ref":"Playwright.SDK.Channel.Catalog.html#put/2"},{"type":"function","title":"Returns - Playwright.SDK.Channel.Catalog.put/2","doc":"- `resource` (the same as provided)","ref":"Playwright.SDK.Channel.Catalog.html#put/2-returns"},{"type":"function","title":"Arguments - Playwright.SDK.Channel.Catalog.put/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `catalog`  | param  | `pid()`    | PID for the Catalog server |\n| `resource` | param  | `struct()` | The resource to store |","ref":"Playwright.SDK.Channel.Catalog.html#put/2-arguments"},{"type":"function","title":"Playwright.SDK.Channel.Catalog.rm_r/2","doc":"Removes a resource from the `Catalog`, along with its legacy.","ref":"Playwright.SDK.Channel.Catalog.html#rm_r/2"},{"type":"function","title":"Returns - Playwright.SDK.Channel.Catalog.rm_r/2","doc":"- `:ok`","ref":"Playwright.SDK.Channel.Catalog.html#rm_r/2-returns"},{"type":"function","title":"Arguments - Playwright.SDK.Channel.Catalog.rm_r/2","doc":"| key/name   | type   |            | description |\n| ---------- | ------ | ---------- | ----------- |\n| `catalog`  | param  | `pid()`    | PID for the Catalog server |\n| `guid`     | param  | `binary()` | GUID for the \"parent\" |","ref":"Playwright.SDK.Channel.Catalog.html#rm_r/2-arguments"},{"type":"function","title":"Playwright.SDK.Channel.Catalog.start_link/1","doc":"Starts a `Playwright.SDK.Channel.Catalog` linked to the current process with the\ngiven \"root\" resource.","ref":"Playwright.SDK.Channel.Catalog.html#start_link/1"},{"type":"function","title":"Return Values - Playwright.SDK.Channel.Catalog.start_link/1","doc":"If the `Catalog` is successfully created and initialized, the function\nreturns `{:ok, pid}`, where `pid` is the PID of the running `Catalog` server.","ref":"Playwright.SDK.Channel.Catalog.html#start_link/1-return-values"},{"type":"function","title":"Arguments - Playwright.SDK.Channel.Catalog.start_link/1","doc":"| key/name | type   |         | description |\n| -------- | ------ | ------- | ----------- |\n| `root`   | param  | `map()` | The root resource for items in the `Catalog`. Provides the `Session` for its descendants |","ref":"Playwright.SDK.Channel.Catalog.html#start_link/1-arguments"},{"type":"module","title":"Playwright.SDK.Config","doc":"Configuration for Playwright.","ref":"Playwright.SDK.Config.html"},{"type":"module","title":"Overview - Playwright.SDK.Config","doc":"config :playwright, ConnectOptions,\n      [...]\n\n    config :playwright, LaunchOptions,\n      [...]\n\n    config :playwright, PlaywrightTest,\n      [...]","ref":"Playwright.SDK.Config.html#module-overview"},{"type":"module","title":"Details for `ConnectOptions` - Playwright.SDK.Config","doc":"Configuration for connecting to a running Playwright browser server over a\nWebSocket.\n\n### `ws_endpoint` (required)\n\nA browser websocket endpoint to which the runner will connect.\n\nThis option is required when using the `:driver` transport to communicate with\na Playwright browser server.\n\ne.g.,\n\n    config :playwright, ConnectOptions,\n      ws_endpoint: \"ws://localhost:3000/\"","ref":"Playwright.SDK.Config.html#module-details-for-connectoptions"},{"type":"module","title":"Details for `LaunchOptions` - Playwright.SDK.Config","doc":"Configuration for Playwright browser server launch commands.\n\n### `args` (optional)\n\nAdditional arguments to pass to the browser instance. The list of Chromium\nflags may be found [online](http://peter.sh/experiments/chromium-command-line-switches/).\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      args: [\n        \"--use-fake-ui-for-media-stream\",\n        \"--use-fake-device-for-media-stream\"\n      ]\n\n### `channel` (optional)\n\nBrowser distribution channel for Chromium. Supported values are:\n\n  - `chrome`\n  - `chrome-beta`\n  - `chrome-dev`\n  - `chrome-canary`\n  - `msedge`\n  - `msedge-beta`\n  - `msedge-dev`\n  - `msedge-canary`\n\nRead more about using Google Chrome and Microsoft Edge\n[online](https://playwright.dev/docs/browsers#google-chrome--microsoft-edge).\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      channel: \"chrome\"\n\n### `chromium_sandbox` (optional)\n\nEnable Chromium sandboxing. Defaults to `false`.\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      chromium_sandbox: true\n\n### `devtools` (optional)\n\nWith Chromium, specifies whether to auto-open a \"Developer Tools\" panel for\neach tab. If this option is `true`, the `headless` option will be set to\n`false`.\n\nDefaults to `false`.\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      devtools: true\n\n### `headless` (optional)\n\nSpecifies whether to run the browser in \"headless\" mode. See:\n\n  - [headless Chromium](https://developers.google.com/web/updates/2017/04/headless-chrome)\n  - [headless Firefox](https://developer.mozilla.org/en-US/docs/Mozilla/Firefox/Headless_mode)\n\nDefaults to `true` unless the `devtools` option is `true`.\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      headless: false # e.g., see a browser window pop up in \"dev\".\n\n### `downloads_path` (optional)\n\n**WARNING: not yet implemented**\n\nIf specified, accepted downloads are written to this directory. Otherwise, a\ntemporary directory is created and is removed when the browser is closed.\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      downloads_path: \"./doc/downloads\"\n\n### `env` (optional)\n\n**WARNING: not yet implemented**\n\nEnvironment variables that will be made visible to the browser. Defaults to\n`System.get_env/0`.\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      env: [\"DEBUG\", \"true\"]\n\n### `executable_path` (optional)\n\nA filesystem path to a browser executable to run instead of the bundled\nbrowser. If `executable_path` is a relative path, then it is resolved relative\nto the current working directory.\n\n**Chromium-only**\n\nPlaywright can also be used to control the Google Chrome or Microsoft Edge\nbrowsers, but it works best with the bundled version of Chromium. There is no\nguarantee that it will work with any other version.\n\n**Use `executable_path` option with extreme caution.**\n\ne.g.,\n\n    config :playwright, LaunchOptions,\n      executable_path: \"/Applications/...\"\n\n### `driver_path` (optional)\n\nA filesystem path to the playwright cli.js file to use instead of the default\nassets path.\n\n**Chromium-only**\n\nThis can be helpful for packaged releases or systems where the node_module may\nbe located elsewhere on the filesystem.\n\n**Use `driver_path` option with extreme caution.**\n\ne.g.,\n\n    config :playwright, ConnectOptions,\n      driver_path: \"/Cache/.../playwright/cli.js\"","ref":"Playwright.SDK.Config.html#module-details-for-launchoptions"},{"type":"module","title":"Details for `PlaywrightTest` - Playwright.SDK.Config","doc":"Configuration for usage of `PlaywrightTest.Case`.\n\n### `transport` (optional)\n\nOne of `:driver` or `:websocket`, defaults to `:driver`.\n\nAdditional configuration may be required depending on the transport\nconfiguration:\n\n  - `LaunchOptions` for the `:driver` transport\n  - `ConnectOptions` for the `:websocket` transport\n\ne.g.,\n\n    config :playwright, PlaywrightTest,\n      transport: :websocket","ref":"Playwright.SDK.Config.html#module-details-for-playwrighttest"},{"type":"module","title":"PlaywrightTest.Case","doc":"Use `PlaywrightTest.Case` in an ExUnit test module to start a Playwright server and put it into the test context.","ref":"PlaywrightTest.Case.html"},{"type":"module","title":"Examples - PlaywrightTest.Case","doc":"defmodule Example.PageTest do\n      use PlaywrightTest.Case\n\n      describe \"features w/ default context\" do\n        test \"goes to a page\", %{page: page} do\n          text =\n            page\n            |> Playwright.Page.goto(\"https://playwright.dev\")\n            |> Playwright.Page.text_content(\".navbar__title\")\n\n          assert text == \"Playwright\"\n        end\n      end\n    end\n\n    defmodule Example.BrowserTest do\n      use PlaywrightTest.Case\n\n      describe \"features w/out `page` context\" do\n        @tag exclude: [:page]\n        test \"goes to a page\", %{browser: browser} do\n          page =\n            browser\n            |> Playwright.Browser.new_page()\n\n          text =\n            page\n            |> Playwright.Page.goto(\"https://playwright.dev\")\n            |> Playwright.Page.text_content(\".navbar__title\")\n\n          assert text == \"Playwright\"\n\n          # must close test-created `page`\n          Playwright.Page.close(page)\n        end\n      end\n    end","ref":"PlaywrightTest.Case.html#module-examples"},{"type":"extras","title":"Read Me","doc":"# Playwright for Elixir\n\n**NOTE:** This package is currently in \"preview\". The features are not yet at parity with other Playwright implementations. Once `playwright-elixir` is at or near parity with [`playwright`](https://github.com/microsoft/playwright), the version number will be updated to mirror the supported version of `playwright`.","ref":"readme.html"},{"type":"extras","title":"Overview - Read Me","doc":"[Playwright](https://github.com/mechanical-orchard/playwright-elixir) is an Elixir library to automate Chromium, Firefox and WebKit with a single API. Playwright is built to enable cross-browser web automation that is **ever-green**, **capable**, **reliable** and **fast**. [See how Playwright is better](https://playwright.dev/docs/why-playwright).","ref":"readme.html#overview"},{"type":"extras","title":"Installation - Read Me","doc":"The package can be installed by adding `playwright` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:playwright, \"~> 1.44.0-alpha.4\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Read Me","doc":"- [README](https://hexdocs.pm/playwright/readme.html)\n- [Getting started](https://hexdocs.pm/playwright/basics-getting-started.html)\n- [API Reference](https://hexdocs.pm/playwright/api-reference.html)","ref":"readme.html#usage"},{"type":"extras","title":"Example - Read Me","doc":"```elixir\ndefmodule Test.ExampleTest do\n  use ExUnit.Case, async: true\n  use PlaywrightTest.Case\n\n  describe \"Navigating to playwright.dev\" do\n    test \"works\", %{browser: browser} do\n      page = Playwright.Browser.new_page(browser)\n\n      Playwright.Page.goto(page, \"https://playwright.dev\")\n      text = Playwright.Page.text_content(page, \".navbar__title\")\n\n      assert text == \"Playwright\"\n      Playwright.Page.close(page)\n    end\n  end\nend\n```","ref":"readme.html#example"},{"type":"extras","title":"Contributing - Read Me","doc":"","ref":"readme.html#contributing"},{"type":"extras","title":"Getting started - Read Me","doc":"1. Clone the repo\n2. Run `bin/dev/doctor` and for each problem, either use the suggested remedies or fix it some other way\n3. Run `bin/dev/test` to run the test suite make sure everything is working","ref":"readme.html#getting-started"},{"type":"extras","title":"Day-to-day - Read Me","doc":"- Get latest code: `bin/dev/update`\n- Run tests: `bin/dev/test`\n- Start server: `bin/dev/start`\n- Run tests and push: `bin/dev/shipit`","ref":"readme.html#day-to-day"},{"type":"extras","title":"Releasing - Read Me","doc":"1. Update the version in `mix.exs`\n   a. Search for and update the version anywhere it appears in the repo, such as this README\n2. `git tag -a v${version_number}` such that the tag look like `v1.44.0-alpha.3` or `v1.44.0`\n3. `git push --tags`\n4. `mix hex.publish`","ref":"readme.html#releasing"},{"type":"extras","title":"Getting Started","doc":"# Getting Started\n\n- [Release Notes](/basics-release-notes.html)\n- [System Requirements](#system-requirements)","ref":"basics-getting-started.html"},{"type":"extras","title":"Installation - Getting Started","doc":"The package can be installed by adding `playwright` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:playwright, \"~> 1.18.0-alpha.1\"}\n  ]\nend\n```\n\nTo ensure Playwright's runtime dependencies (e.g., browsers) are available, execute the following:\n\n```bash\n$ mix playwright.install\n```","ref":"basics-getting-started.html#installation"},{"type":"extras","title":"Usage - Getting Started","doc":"Once installed, you can `alias` and/or `import` Playwright in your Elixir module, and launch any of the 3 browsers (`chromium`, `firefox` and `webkit`).\n\n```elixir\n{:ok, browser} = Playwright.launch(:chromium)\npage =\n  browser |> Playwright.Browser.new_page()\n\npage\n  |> Playwright.Page.goto(\"http://example.com\")\n\npage\n  |> Playwright.Page.title()\n  |> IO.puts()\n\nbrowser\n  |> Playwright.Browser.close()\n```","ref":"basics-getting-started.html#usage"},{"type":"extras","title":"System requirements - Getting Started","doc":"TBD","ref":"basics-getting-started.html#system-requirements"},{"type":"extras","title":"Inspector","doc":"# Inspector\n\n...","ref":"basics-inspector.html"},{"type":"extras","title":"Trace Viewer","doc":"# Trace Viewer\n\n...","ref":"basics-trace-viewer.html"},{"type":"extras","title":"Test Generator","doc":"# Test Generator\n\n...","ref":"basics-test-generator.html"},{"type":"extras","title":"Debugging Tools","doc":"# Debugging Tools\n\n...","ref":"basics-debugging-tools.html"},{"type":"extras","title":"Release Notes","doc":"# Release Notes\n\nTBD (still in preview at the moment)","ref":"basics-release-notes.html"},{"type":"extras","title":"Assertions","doc":"# Assertions\n\n...","ref":"guides-assertions.html"},{"type":"extras","title":"Authentication","doc":"# Authentication\n\n...","ref":"guides-authentication.html"},{"type":"extras","title":"Auto-waiting","doc":"# Auto-waiting\n\n...","ref":"guides-auto-waiting.html"},{"type":"extras","title":"Browser Contexts","doc":"# Browser Contexts\n\n...","ref":"guides-browser-contexts.html"},{"type":"extras","title":"Browsers","doc":"# Browsers\n\n...","ref":"guides-browsers.html"},{"type":"extras","title":"Chrome Extensions","doc":"# Chrome Extensions\n\n...","ref":"guides-chrome-extensions.html"},{"type":"extras","title":"Command-line Tools","doc":"# Command-line Tools\n\n...","ref":"guides-command-line-tools.html"},{"type":"extras","title":"Dialogs","doc":"# Dialogs\n\n...","ref":"guides-dialogs.html"},{"type":"extras","title":"Downloads","doc":"# Downloads\n\n...","ref":"guides-downloads.html"},{"type":"extras","title":"Emulation","doc":"# Emulation\n\n...","ref":"guides-emulation.html"},{"type":"extras","title":"Evaluating JavaScript","doc":"# Evaluating JavaScript\n\n...","ref":"guides-evaluating-javascript.html"},{"type":"extras","title":"Events","doc":"# Events\n\n...","ref":"guides-events.html"},{"type":"extras","title":"Extensibility","doc":"# Extensibility\n\n...","ref":"guides-extensibility.html"},{"type":"extras","title":"Frames","doc":"# Frames\n\n...","ref":"guides-frames.html"},{"type":"extras","title":"Handles","doc":"# Handles\n\n...","ref":"guides-handles.html"},{"type":"extras","title":"Input","doc":"# Input\n\n...","ref":"guides-input.html"},{"type":"extras","title":"Locators","doc":"# Locators\n\n...","ref":"guides-locators.html"},{"type":"extras","title":"Navigations","doc":"# Navigations\n\n...","ref":"guides-navigations.html"},{"type":"extras","title":"Network","doc":"# Network\n\n...","ref":"guides-network.html"},{"type":"extras","title":"Page Object Models","doc":"# Page Object Models\n\n...","ref":"guides-page-object-models.html"},{"type":"extras","title":"Pages","doc":"# Pages\n\n...","ref":"guides-pages.html"},{"type":"extras","title":"Screenshots","doc":"# Screenshots\n\n...","ref":"guides-screenshots.html"},{"type":"extras","title":"Selectors","doc":"# Selectors\n\n...","ref":"guides-selectors.html"},{"type":"extras","title":"Verification","doc":"# Verification\n\n...","ref":"guides-verification.html"},{"type":"extras","title":"Videos","doc":"# Videos\n\n...","ref":"guides-videos.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}